#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

unsigned int numtextures,numiblocks,numiblocks2,numvblocks, numobjblocks;
char destFlag=0, parseFlag=0, lodsFlag = 0, lmapFlag = 0;
char defuser[] = "\\\\MSHOME\\Administrator";

struct vector3f
{
	float x,y,z; 
};

struct vector2f
{
	float tx,ty; 
};

#define VEC_Cross(a, b, c)((c).x = (a).y * (b).z - (a).z * (b).y, (c).y = (a).z * (b).x - (a).x * (b).z, (c).z = (a).x * (b).y - (a).y * (b).x)
#define VEC_Subtract(a, b, c)((c).x = (a).x - (b).x, (c).y = (a).y - (b).y, (c).z = (a).z - (b).z)
#define VEC_Magnitude(v)(sqrt((v).x * (v).x + (v).y * (v).y + (v).z * (v).z))
#define VEC_Normalizef(v){ float __mag = 1.0f / (float)VEC_Magnitude(v); \
(v).x *= __mag; (v).y *= __mag; (v).z *= __mag; }
void Make_Normal(vector3f a, vector3f b, vector3f c, vector3f * n)
{
	vector3f v1 = {0,0,0},v2 = {0,0,0};
	VEC_Subtract(b, a, v1);
	VEC_Subtract(c, a, v2);
	VEC_Cross(v1, v2, *n);
	VEC_Normalizef(*n);
}

struct lev_blk
{
	unsigned short type; // 1..8
	unsigned short fcomp; // compressed if = 32768
  unsigned int size;
};

struct ogf_bbox {
	struct vector3f		min;
	struct vector3f		max;
};

struct ogf_bsphere {
	struct vector3f		c;
	float			r;
};

struct cform_blk
{
  unsigned int version;
  unsigned int num_verts;
  unsigned int num_tris;
  ogf_bbox bb;
};

struct VTX_BLK
{
	struct vector3f p;
	unsigned int n,t,b;
	short u,v;
	unsigned int unused;
};

struct blk_21
{
 unsigned int vBlkID;
 unsigned int vFirst;
 unsigned int vCount;
 unsigned int iBlkID;
 unsigned int iFirst;
 unsigned int iCount;
};

struct ChunkIFF
{
	unsigned int type, size;
};

struct OGFVertex_v0 // x-ray actor_editor (0x00000112)
{
	struct vector3f p;
	struct vector3f n;
	float u,v;
	float lu,lv;
};

struct OGFHeader_v4 // 0x2C (44)
{
 unsigned char format_version;
 unsigned char type;
 unsigned short shader_id;
 struct ogf_bbox		bb;
 struct ogf_bsphere	bs;
};

///////////////////////////////

#define MAX_OBJ_COUNT 30000
#define MAX_TXT_COUNT 1000

struct swidata {
  unsigned int m_reserved[4];
  unsigned int swicout;
};

struct slide_window {
	unsigned int		offset;
	unsigned short		num_tris;
	unsigned short		num_verts;
};

struct obj_blk // for ogf export
{
 unsigned short rangecount;
 unsigned char code;
 unsigned short texture;
 blk_21 range[2];
 OGFVertex_v0 * geom_vBlk;
 unsigned short * geom_iBlk;
/*
 OGFVertex_v0 * cform_vBlk;
 unsigned short * cform_iBlk;
*/
 char * m_dds;
 char * m_shd;
 char * m_lm_dds;
 float xform[16];
 struct ogf_bbox		bb;
 struct ogf_bsphere	bs;
 unsigned char dds_type;
#ifdef USE_LODS
 unsigned int lodcount;
 slide_window * lod;
#endif
 unsigned short swi;
};

obj_blk * o;
#ifndef USE_LODS
slide_window * swiblk;
#endif
unsigned short ocount = 0;
unsigned short orange = 0;
char * tmp_m_dds[MAX_TXT_COUNT];
char * tmp_m_shd[MAX_TXT_COUNT];
char * tmp_m_lm_dds[MAX_TXT_COUNT];

struct merged_blk
{
 OGFVertex_v0 * geom_vBlk;
 unsigned short * geom_iBlk;
 unsigned int iCount;
 unsigned int vCount;
 char * m_dds;
 char * m_shd;
 unsigned short texture;
};

#ifdef LINE_COMPACT
	 merged_blk mix[MAX_TXT_COUNT];
#else
	 merged_blk mix[MAX_TXT_COUNT*2];
#endif
///////////////////////////////

unsigned int memcmp_vec8(void * a, void * b) // 8 * 4(long) = 32
{
unsigned int * p0 = (unsigned int *)a;
unsigned int * p1 = (unsigned int *)b;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
return 0;
}

int version;

float Dist3D(float x1, float y1, float z1, float x2, float y2, float z2)
{
	return sqrt(((x1-x2)*(x1-x2)) + ((y1-y2)*(y1-y2)) + ((z1-z2)*(z1-z2)));
}

int DecodeChunk(lev_blk h,FILE *inputFile)
{
	printf(" DecodeChunk(0x%04X, 0x%08X)\n",h.type,h.size);

	if (h.fcomp == 0x8000) { printf("ERR: compressed block.\n"), _getch(); h.type = 0xFF; } // force_end

	switch (h.type)
	{
	case 0x01: // level; level.geom, UNUSED_CHUNK_ID
  {
	fread(&version,h.size,1,inputFile);
	printf("  level version = 0x%08X\n",version);
	return 1;
	}
	case 0x02: // level, LEV_SHADERS
  {
	fread(&numtextures,2,1,inputFile);
	printf("  textures = %d\n",numtextures);
  if (numtextures > MAX_TXT_COUNT) printf("!!! too many textures, maximum is %u\n",MAX_TXT_COUNT), _getch();

	char *tmpdata = new char[h.size-2];
	fread(tmpdata,h.size-2,1,inputFile);
	unsigned int p=0, plen;
	for (unsigned int i = 0;i< numtextures; i++) 
	{
  if (!destFlag) printf("   [%d]: s,t ",i); // s,t,m ; m unused

  plen = 0;
  while(tmpdata[p+plen] != 0x00) plen++;
  tmp_m_shd[i] = new char[plen+1];
  memcpy(tmp_m_shd[i],&tmpdata[p],plen); tmp_m_shd[i][plen] = 0;
  p += plen; p++;
  if (!destFlag) printf("'%s', ",tmp_m_shd[i]);

  plen = 0;
  while(tmpdata[p+plen] != 0x00) plen++;
  tmp_m_dds[i] = new char[plen+1];
  memcpy(tmp_m_dds[i],&tmpdata[p],plen); tmp_m_dds[i][plen] = 0;
  p += plen; p++; 
  if (!destFlag) printf("'%s'\n",tmp_m_dds[i]);

  while(tmpdata[p] != 0x00) p++;
  //if (!destFlag) printf("'--skipped--'\n");

  p+=5;
	}
	delete [] tmpdata;
	return 1;
	}

	case 0x03: // level, LEVEL_PARTS_CHUNK_ID
  {
  unsigned int szAll, szObj, idObj;
  szAll = h.size;

  blk_21 iv;
  unsigned int i = 0, bdone = 0; 
  unsigned short txt;
  orange = 0;

  while (szAll > 0)
  {

	fread(&idObj,4,1,inputFile);
	fread(&szObj,4,1,inputFile);
	if (!destFlag) printf("  [ OBJECT#%04d ] size %d\n",idObj,szObj);

	char *tmpdata = new char[szObj];
	fread(tmpdata,szObj,1,inputFile);

	if (tmpdata[0] == 0x15) // subblk = 15
	{
	iv.vBlkID = iv.iBlkID = ocount;
	memcpy(&iv.vFirst, &tmpdata[12], 8);
	memcpy(&iv.iFirst, &tmpdata[20], 8);
	memcpy(&txt,&tmpdata[38],2);
	
   if (!destFlag)  printf("    IV_CONTAINER: (v:#%d,%d,%d) (i:#%d,%d,%d), t:%d\n",
    iv.vBlkID,iv.vFirst,iv.vCount,iv.iBlkID,iv.iFirst,iv.iCount,txt);
  else
  {
  o[ocount].range[orange].vBlkID = iv.vBlkID;
  o[ocount].range[orange].vFirst = iv.vFirst;
  o[ocount].range[orange].vCount = iv.vCount;
  o[ocount].range[orange].iBlkID = iv.iBlkID;
  o[ocount].range[orange].iFirst = iv.iFirst;
  o[ocount].range[orange].iCount = iv.iCount;
	o[ocount].texture = txt;
  ocount ++;
  }
  }
	delete [] tmpdata;
  szAll -= 8;
  szAll -= szObj;
  }
  printf("OK\n");

	return 1;
  }

	case 0x09: // level.geom, LEV_V_BLOCKS
  {
  int tot_vblks = 0, ii;

  numvblocks = h.size / 32;

	printf("  numvblocks = %d\n",numvblocks);
	VTX_BLK * v_tmp = new VTX_BLK[numvblocks];
  tot_vblks += numvblocks;
	fread(v_tmp,sizeof(VTX_BLK),numvblocks,inputFile);

/////////////////////////
   if (destFlag) 
   for (ii = 0; ii < ocount; ii++)
   {
   unsigned int bsz = o[ii].range[0].vCount;
   unsigned int bst = o[ii].range[0].vFirst;
   o[ii].geom_vBlk = new OGFVertex_v0[bsz];
	 o[ii].bb.min = o[ii].bb.max = v_tmp[bst].p;

   for (unsigned int jj = 0; jj < o[ii].range[0].vCount; jj++)
   {
   o[ii].geom_vBlk[jj].p = v_tmp[bst+jj].p;
   o[ii].geom_vBlk[jj].n.x = ((v_tmp[bst+jj].n << 16) & 0xFF) / 255.0f;
   o[ii].geom_vBlk[jj].n.y = ((v_tmp[bst+jj].n << 8) & 0xFF) / 255.0f;
   o[ii].geom_vBlk[jj].n.z = (v_tmp[bst+jj].n & 0xFF) / 255.0f;
   o[ii].geom_vBlk[jj].u = v_tmp[bst+jj].u / 1024.0f;
   o[ii].geom_vBlk[jj].v = v_tmp[bst+jj].v / 1024.0f;

		// find bbox
   if (o[ii].geom_vBlk[jj].p.x < o[ii].bb.min.x) o[ii].bb.min.x = o[ii].geom_vBlk[jj].p.x;
   if (o[ii].geom_vBlk[jj].p.y < o[ii].bb.min.y) o[ii].bb.min.y = o[ii].geom_vBlk[jj].p.y;
   if (o[ii].geom_vBlk[jj].p.z < o[ii].bb.min.z) o[ii].bb.min.z = o[ii].geom_vBlk[jj].p.z;
   if (o[ii].geom_vBlk[jj].p.x > o[ii].bb.max.x) o[ii].bb.max.x = o[ii].geom_vBlk[jj].p.x;
   if (o[ii].geom_vBlk[jj].p.y > o[ii].bb.max.y) o[ii].bb.max.y = o[ii].geom_vBlk[jj].p.y;
   if (o[ii].geom_vBlk[jj].p.z > o[ii].bb.max.z) o[ii].bb.max.z = o[ii].geom_vBlk[jj].p.z;
   }
   o[ii].bs.r = (Dist3D(o[ii].bb.min.x,o[ii].bb.min.y,o[ii].bb.min.z,o[ii].bb.max.x,o[ii].bb.max.y,o[ii].bb.max.z) / 2.0f);
	 o[ii].bs.c.x = ((o[ii].bb.min.x + o[ii].bb.max.x) / 2.0f);
	 o[ii].bs.c.y = ((o[ii].bb.min.y + o[ii].bb.max.y) / 2.0f);
	 o[ii].bs.c.z = ((o[ii].bb.min.z + o[ii].bb.max.z) / 2.0f);
   }
/////////////////////////
 	 delete [] v_tmp;

	return 1;
	}

	case 0x0A: // level.geom, LEV_I_BLOCKS
  {
  unsigned short ii; unsigned int tot_f = 0, tot_i = 0;
  numiblocks = h.size / 2;
	printf("  numiblocks = %d\n",numiblocks);
	unsigned short * i_tmp = new unsigned short[numiblocks];
	printf("  iBlock[%d]: '%d faces, %d indexes'\n",0,numiblocks/3,numiblocks);
  tot_f += (numiblocks/3); tot_i += numiblocks;
	fread(i_tmp,sizeof(unsigned short),numiblocks,inputFile);

/////////////////////////
   if (destFlag) 
   for (ii = 0; ii < ocount; ii++)
   {
   unsigned int bsz = o[ii].range[0].iCount;
   unsigned int bst = o[ii].range[0].iFirst;
   o[ii].geom_iBlk = new unsigned short[bsz];
   memcpy(o[ii].geom_iBlk,&i_tmp[bst],sizeof(unsigned short)*bsz);
   }
/////////////////////////

  delete [] i_tmp;
	printf("  totals: '%d faces, %d indexes'\n",tot_f,tot_i);

	return 1;
	}

	case 0x05: // level
	case 0x0B: // ?????????
	case 0x08: // level, LEV_SECTORS
	case 0x0E: // ??????????
  case 0x04: // level, LEV_PORTALS
  case 0xFF: // forced_end
  {
		//printf("  UNKNOWN LEV_BLK = %d\n",h.type); 
    //_getch();
		char *tmpdata = new char[h.size];
		fread(tmpdata,h.size,1,inputFile);
		delete [] tmpdata;
		return 0;}
	default: { printf("unknown lev_blk = %d\n",h.type); return 0;}
	}
}

int main(int argc, char* argv[])
{
  lev_blk hdr;
  cform_blk hdr2;
  unsigned int i, fullsize=0, j;
	char fileName[256], intName[256];
	unsigned char mainFlag = 0;
  FILE *inputFile, *outputFile;

 	printf("4A Games Metro 203x level parser-converter [201107xx]\n");

	if (argc < 2) 
  {
  	printf("usage: parse_203 < mode > [ destfile.ogf ] [ internal_name ]\n\tmode: 0/1 - conv: normal/optimized, 0/2 - lods_fake/no_lods_fake,\n\t0/4 - no_lmap/lmap, 0/8 - convert/dump only\n\tdestfile.ogf: destination file (modes 0-7 only)\n\tinternal_name: internal model name\n");
		return 1;
	}

  mainFlag = (char)atoi(argv[1]);

  parseFlag = mainFlag & 1;
  lodsFlag = mainFlag & 2;
  lmapFlag = mainFlag & 4;

	if (mainFlag < 8) 
	{
  if (argc < 3) 
  {
		printf("4A Games PARSE_203x: no arguments given in mode(s) 0 - 7.\n"); return 1;
  }
  else strcpy((char*)fileName,argv[2]), destFlag = 1;
  }
  if (argc > 3) strcpy((char*)intName,argv[3]);

  if (destFlag) o = new obj_blk[MAX_OBJ_COUNT];

  inputFile = fopen("level","rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open 'level'.\n");
  return 1;
  }
  printf("------------------------------\nLoading spatial-DB (level)...\n");
	fseek(inputFile,0,SEEK_END);
  fullsize = ftell(inputFile);
	fseek(inputFile,0,SEEK_SET);
  while(fullsize)
  {
  fread( &hdr, sizeof(lev_blk), 1, inputFile );
  printf("Type 0x%04X, compress 0x%04X, size %d\n",hdr.type,hdr.fcomp,hdr.size);
  DecodeChunk(hdr,inputFile);
  fullsize -= hdr.size; fullsize -= 8;
	}
  fclose(inputFile);
  printf("loading OK\n");

  inputFile = fopen("level.geom_pc","rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open 'level.GEOM_PC'.\n");
  return 1;
  }
  printf("------------------------------\nLoading geometry (level.GEOM_PC)...\n");
	fseek(inputFile,0,SEEK_END);
  fullsize = ftell(inputFile);
	fseek(inputFile,0,SEEK_SET);
  while(fullsize)
  {
  fread( &hdr, sizeof(lev_blk), 1, inputFile );
  printf("Type 0x%04X, compress 0x%04X, size %d\n",hdr.type,hdr.fcomp,hdr.size);
  DecodeChunk(hdr,inputFile);
  fullsize -= hdr.size; fullsize -= 8;
	}
  fclose(inputFile);
  printf("loading OK\n");

//////////////////////////////////////////////////////////////////
//////// check for stage #1
//////////////////////////////////////////////////////////////////


OGFVertex_v0 * tmp_v; //, * tmp_v2, * tmp_v3;
unsigned short * tmp_i;
//int dupcnt = 0;
for (i = 0; i < ocount;i++)
{
tmp_v = new OGFVertex_v0[o[i].range[0].vCount];
tmp_i = new unsigned short[o[i].range[0].iCount];
/*
printf("\rtesting ... ");
tmp_v3 = o[i].geom_vBlk;
for (j=0; j < o[i].range[0].vCount; j++)
{
tmp_v2 = o[i].geom_vBlk;
for (unsigned int k=0; k < o[i].range[0].vCount; k++)
{
if (k > j)
{
if (memcmp_vec8(tmp_v3,tmp_v2) == 0) dupcnt++; // printf ("*"), 
}
tmp_v2++;
}
tmp_v3++;
}
*/
printf("\rcompacting mesh %05u of %05u ...",i,ocount);

  OGFVertex_v0 * tmp_v_src = o[i].geom_vBlk;
	unsigned short * tmp_i_src = o[i].geom_iBlk;
	unsigned int cnt = 0, c;

	for (c = 0; c < o[i].range[0].iCount;c++)
	{
  OGFVertex_v0 * p1 = &tmp_v_src[tmp_i_src[c]];
	for (unsigned int r = 0; r < cnt; r++)
	{
  if (memcmp_vec8(&tmp_v[r],p1) == 0) { tmp_i[c] = r; goto stage2; }
	}
  tmp_v[cnt] = *p1; tmp_i[c] = cnt; cnt++;
	if (cnt >= 65535) break;
stage2:;
	}
	o[i].range[0].vCount = cnt;
	o[i].range[0].iCount = c;
	memcpy(o[i].geom_vBlk,tmp_v,sizeof(OGFVertex_v0) * cnt);
	memcpy(o[i].geom_iBlk,tmp_i,sizeof(unsigned short) * c);
	delete [] tmp_v;
	delete [] tmp_i;
}
/*
printf("\nSTAGE#1: total dups %u, economy %u\n",dupcnt,dupcnt*(sizeof(OGFVertex_v0)-8));

//////////////////////////////////////////////////////////////////
//////// check for dups stage #2
//////////////////////////////////////////////////////////////////

dupcnt = 0;
for (i = 0; i < ocount;i++)
{
printf("\rtesting mesh %05u of %05u ...",i,ocount);
tmp_v = o[i].geom_vBlk;
for (j=0; j < o[i].range[0].vCount; j++)
{
tmp_v2 = o[i].geom_vBlk;
for (unsigned int k=0; k < o[i].range[0].vCount; k++)
{
if (k > j)
{
if (memcmp_vec8(tmp_v,tmp_v2) == 0) dupcnt++; // printf ("*"), 
}
tmp_v2++;
}
tmp_v++;
}
}
printf("\nSTAGE#2: total dups %u, economy %u\n",dupcnt,dupcnt*(sizeof(OGFVertex_v0)-8)); // _getch();

//////////////////////////////////////////////////////////////////
//////// check for dups
//////////////////////////////////////////////////////////////////
*/

  if (!destFlag) return 0;

if (parseFlag == 0) 

{
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

	 unsigned short numblocks = 0; unsigned int obj;

   for (obj = 0; obj < ocount; obj++)
   {
   for (i = 0; i < numtextures; i++)
   {
   if (o[obj].texture == i) 
   {
   o[obj].m_dds = new char[strlen(tmp_m_dds[i])+1], o[obj].m_shd = new char[strlen(tmp_m_shd[i])+1],
   strcpy(o[obj].m_dds,tmp_m_dds[i]),strcpy(o[obj].m_shd,tmp_m_shd[i]);
   if (lmapFlag) if (tmp_m_lm_dds[i]) o[obj].m_lm_dds = new char[strlen(tmp_m_lm_dds[i])+1], strcpy(o[obj].m_lm_dds,tmp_m_lm_dds[i]);
   }
   }
	  printf("o%05u - c,t,s 0x%02X, '%s', '%s', %u, %u\n",
  	obj,o[obj].code, o[obj].m_dds,o[obj].m_shd,o[obj].range[0].vCount,o[obj].range[0].iCount), numblocks++;
   }
   for (i = 0; i < numtextures; i++)
    delete tmp_m_dds[i], delete tmp_m_lm_dds[i], delete tmp_m_shd[i];

  printf("level parse complete\n");

   for (obj = 0; obj < ocount; obj++)
   {
	 printf("obj[%05u of %05u], making normales ... ",obj+1,ocount);
	 for (unsigned int s = 0; s < o[obj].range[0].iCount ; s+=3)
   {
   vector3f a,b,c,n;
	 a = o[obj].geom_vBlk[o[obj].geom_iBlk[s]].p;
	 b = o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].p;
	 c = o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].p;
   Make_Normal(a,b,c,&n);
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n = 
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n = 
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n = n;
/*
	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x != n.x) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		n.x, o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x = n.x;
   }
   else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y != n.y) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		n.y, o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y = n.y;
   }
   else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z != n.z) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		n.z, o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z = n.z;
   }
   else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x != n.x) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		n.x, o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x = n.x;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y != n.y) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		n.y, o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y = n.y;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z != n.z) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		n.z, o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z = n.z;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x != n.x) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		n.x, o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x = n.x;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y != n.y) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		n.y, o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y = n.y;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y);

	 if (o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z != n.z) 
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		n.z, o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z = n.z;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z);
*/
   }
	 printf("OK\r");
   }
	 printf("\n");
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

	 hdr2.bb.min = hdr2.bb.max = o[0].bs.c;
   for (unsigned int ii = 0; ii < numblocks; ii++)
   {
		// find general bbox
   if (o[ii].bb.min.x < hdr2.bb.min.x) hdr2.bb.min.x = o[ii].bb.min.x;
   if (o[ii].bb.min.y < hdr2.bb.min.y) hdr2.bb.min.y = o[ii].bb.min.y;
   if (o[ii].bb.min.z < hdr2.bb.min.z) hdr2.bb.min.z = o[ii].bb.min.z;
   if (o[ii].bb.max.x > hdr2.bb.max.x) hdr2.bb.max.x = o[ii].bb.max.x;
   if (o[ii].bb.max.y > hdr2.bb.max.y) hdr2.bb.max.y = o[ii].bb.max.y;
   if (o[ii].bb.max.z > hdr2.bb.max.z) hdr2.bb.max.z = o[ii].bb.max.z;
   }

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

  unsigned int tot_i = 0, tot_v = 0;

  printf("creating '%s'\n",fileName);
  outputFile = fopen(fileName,"wb");

  ChunkIFF * ih = new ChunkIFF;
  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  OGFHeader_v4 * hdr4 = new OGFHeader_v4;
  hdr4->format_version = 4;
  hdr4->type = 1;
  hdr4->shader_id = 0;
  hdr4->bb = hdr2.bb;
  hdr4->bs.r = (Dist3D(hdr2.bb.min.x,hdr2.bb.min.y,hdr2.bb.min.z,hdr2.bb.max.x,hdr2.bb.max.y,hdr2.bb.max.z)/ 2.0f);
  hdr4->bs.c.x = ((hdr2.bb.min.x + hdr2.bb.max.x) / 2.0f);
  hdr4->bs.c.y = ((hdr2.bb.min.y + hdr2.bb.max.y) / 2.0f);
  hdr4->bs.c.z = ((hdr2.bb.min.z + hdr2.bb.max.z) / 2.0f);
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x12; // text info
  if (argc > 3) ih->size = 0x59 + strlen(intName); else ih->size = 0x6E; // guessed :)
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  i = 0; 
  if (argc > 3) 
  fprintf(outputFile,"%s.object",intName);
  else fputs("test_level\\test_level.object",outputFile);
  fwrite(&i,1,1,outputFile); 

  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time

  ih->type = 0x09; // childrens
  ih->size = 0;
	for (j = 0;j < numblocks; j++)
	{
	if (lodsFlag) if (strstr(o[j].m_dds,"prop_fake")) continue;
  ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
#ifdef USE_LODS
	if (o[j].lodcount)
  ih->size += (sizeof(swidata)+(sizeof(slide_window)*o[j].lodcount))+8;
#endif
	if (lmapFlag) if (o[j].dds_type == 1) printf("************** lmap is '%s'\n",o[j].m_lm_dds),
  ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_lm_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
  }

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  printf("making %u blocks\n",numblocks);

  unsigned int k = 0;
	for (j = 0;j < numblocks; j++)
	{
	if (lodsFlag) if (strstr(o[j].m_dds,"prop_fake")) continue;

	// child start

  ih->type = k; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
#ifdef USE_LODS
	if (o[j].lodcount)
  ih->size += (sizeof(swidata)+(sizeof(slide_window)*o[j].lodcount))+8;
#endif

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	// .... 1.2.3.4

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb = o[j].bb;
  hdr4->bs = o[j].bs;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x02; // texture
  ih->size = strlen(o[j].m_dds) + strlen(o[j].m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(o[j].m_dds,outputFile); fwrite(&i,1,1,outputFile); 
  fputs(o[j].m_shd,outputFile); fwrite(&i,1,1,outputFile); 

	tot_v += o[j].range[0].vCount;
  ih->type = 0x03; // verts
  ih->size = (o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = o[j].range[0].vCount; 
  fwrite(&i,4,1,outputFile);
  for (unsigned int s = 0; s < i ; s++)
	fwrite(&o[j].geom_vBlk[s],sizeof(OGFVertex_v0)-8,1,outputFile);
	
	tot_i += o[j].range[0].iCount;
  ih->type = 0x04; // idx
  ih->size = (o[j].range[0].iCount*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = o[j].range[0].iCount; 
  fwrite(&i,4,1,outputFile);
	fwrite(o[j].geom_iBlk,sizeof(unsigned short),i,outputFile);

#ifdef USE_LODS
	if (o[j].lodcount)
	{
	swidata s;
  ih->type = 0x06; // lod
  ih->size = sizeof(swidata)+(sizeof(slide_window)*o[j].lodcount);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  s.swicout = o[j].lodcount;
	fwrite(&s,sizeof(swidata),1,outputFile);
	fwrite(o[j].lod,sizeof(slide_window),o[j].lodcount,outputFile);
	}
#endif

	printf("."); if ((k % 50)==0) printf("\r%u",k);
	k++;
	// child end 

	if (lmapFlag) if (o[j].dds_type == 1) {
	// child start

  ih->type = k; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_lm_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	// .... 1.2.3.4

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb = o[j].bb;
  hdr4->bs = o[j].bs;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x02; // texture
  ih->size = strlen(o[j].m_lm_dds) + strlen(o[j].m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(o[j].m_lm_dds,outputFile); fwrite(&i,1,1,outputFile);
  fputs(o[j].m_shd,outputFile); fwrite(&i,1,1,outputFile);
	tot_v += o[j].range[0].vCount;
  ih->type = 0x03; // verts
  ih->size = (o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = o[j].range[0].vCount;
  fwrite(&i,4,1,outputFile);
  for (unsigned int s = 0; s < i ; s++)
  //o[j].geom_vBlk[s].u = o[j].geom_vBlk[s].lu, o[j].geom_vBlk[s].v = o[j].geom_vBlk[s].lv,
  o[j].geom_vBlk[s].p.y+=0.01f, // lmap is upper
	fwrite(&o[j].geom_vBlk[s],sizeof(OGFVertex_v0)-8,1,outputFile);
	
	tot_i += o[j].range[0].iCount;
  ih->type = 0x04; // idx
  ih->size = (o[j].range[0].iCount*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = o[j].range[0].iCount;
  fwrite(&i,4,1,outputFile);
	fwrite(o[j].geom_iBlk,sizeof(unsigned short),i,outputFile);

	printf("*"); if ((k % 50)==0) printf("\r%u",k);
	k++;
	// child end (lmap)
	}
	}

  delete [] o;

  delete hdr4;
  delete ih;

  if (outputFile) fclose(outputFile);
  if (argc > 3) printf("\nwriting level '%s' to '%s' [v %u, i %u] OK\n",intName,fileName,tot_v,tot_i);
	else printf("\nwriting '%s' [v %u, i %u] OK\n",fileName,tot_v,tot_i);
///////////////////////////////////////
} // parseFlag == 0
else if (parseFlag == 1) 

{

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

   for (unsigned int obj = 0; obj < ocount; obj++)
   {
   for (i = 1; i < numtextures; i++) // from 1 !!!
   {
   if (o[obj].texture == i) 
   {
   o[obj].m_dds = new char[strlen(tmp_m_dds[i])+1], o[obj].m_shd = new char[strlen(tmp_m_shd[i])+1],
   strcpy(o[obj].m_dds,tmp_m_dds[i]),strcpy(o[obj].m_shd,tmp_m_shd[i]);
   if (lmapFlag) if (tmp_m_lm_dds[i]) o[obj].m_lm_dds = new char[strlen(tmp_m_lm_dds[i])+1], strcpy(o[obj].m_lm_dds,tmp_m_lm_dds[i]);
   }
   }
   }

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
   
#define LINE_COMPACT
//////////////////////////////////////////
#ifdef LINE_COMPACT

   unsigned short mix_numt=0;
 
   printf(" compacting (full): first pass\n");
   for (unsigned short t = 1; t < numtextures; t++) // from 1 !!!
   {
   unsigned int max_v=0, max_i=0;
   for (unsigned int obj = 0; obj < ocount; obj++)
   if ((o[obj].texture == t) && (o[obj].range[0].vCount)) 
   {
   //printf(" -> obj = %u, v = %u, i = %u\n",obj,o[obj].range[0].vCount,o[obj].range[0].iCount);
   unsigned int vtmp = max_v + o[obj].range[0].vCount;
   if (vtmp <= 65535)
   max_v += o[obj].range[0].vCount, max_i += o[obj].range[0].iCount;
   //printf("obj %u chained\n",obj);
   else
   {
   //printf("obj %u eof\n",obj);
   printf("%05i: *texture='%s', max_v=%u, max_i=%u\n",t,tmp_m_dds[t],max_v,max_i);
   mix[mix_numt].texture = t;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[t])], mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[t])],
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[t]),strcpy(mix[mix_numt].m_shd,tmp_m_shd[t]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   //printf(" [%u]:create of vblk[%u],iblk[%u]\n",mix_numt,max_v,max_i);
   //printf(" pre-v\n");
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   //printf(" pre-i\n");
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   //printf(" done make\n");
   mix_numt++;
   max_v = o[obj].range[0].vCount, max_i = o[obj].range[0].iCount;
   }
   }
   if (max_v)
   {
   printf("%05i: +texture='%s', max_v=%u, max_i=%u\n",t,tmp_m_dds[t],max_v,max_i);
   mix[mix_numt].texture = t;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[t])], mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[t])],
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[t]),strcpy(mix[mix_numt].m_shd,tmp_m_shd[t]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   //printf(" [%u]:create of vblk[%u],iblk[%u]\n",mix_numt,max_v,max_i);
   //printf(" pre-v\n");
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   //printf(" pre-i\n");
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   //printf(" done make\n");
   mix_numt++;
   }
   }

   printf(" compacting (full): second pass\n");
   for (i = 0; i < mix_numt; i++)
   {

   unsigned int v_pos = 0, i_pos = 0;
   for (unsigned int obj = 0; obj < ocount; obj++)
   if (mix[i].texture == o[obj].texture)
   {
   unsigned int v_tmp = v_pos + o[obj].range[0].vCount;
   if (v_tmp <= mix[i].vCount)
   {
   memcpy(&mix[i].geom_vBlk[v_pos],o[obj].geom_vBlk,sizeof(OGFVertex_v0)*o[obj].range[0].vCount);
   memcpy(&mix[i].geom_iBlk[i_pos],o[obj].geom_iBlk,sizeof(unsigned short)*o[obj].range[0].iCount);
   if (i_pos) for (unsigned int ii = 0; ii < o[obj].range[0].iCount; ii++)
   mix[i].geom_iBlk[i_pos+ii] += (unsigned short)v_pos;
   v_pos += o[obj].range[0].vCount;
   i_pos += o[obj].range[0].iCount;
   }
   else
   {
   printf("*mix_num %u: max_v=%u, max_i=%u\n",i,v_pos,i_pos);
   i++;
   v_pos = 0; i_pos = 0;
   memcpy(&mix[i].geom_vBlk[v_pos],o[obj].geom_vBlk,sizeof(OGFVertex_v0)*o[obj].range[0].vCount);
   memcpy(&mix[i].geom_iBlk[i_pos],o[obj].geom_iBlk,sizeof(unsigned short)*o[obj].range[0].iCount);
   // if (i_pos) for (unsigned int ii = 0; ii < o[obj].range[0].iCount; ii++)
   // mix[i].geom_iBlk[i_pos+ii] += (unsigned short)v_pos;
   v_pos += o[obj].range[0].vCount;
   i_pos += o[obj].range[0].iCount;
   }
   }
   printf("+mix_num %u: max_v=%u, max_i=%u\n",i,v_pos,i_pos);

   }
   
/////////////////////////
#else // partial compact
/////////////////////////

   unsigned short mix_numt=0, m_first = 0, m_last = 0;
   unsigned int max_v = 0, max_i = 0;

   printf(" compacting (partial,line): first pass\n");

   for (obj = 0; obj < ocount; obj++) // from 1
   {
   printf("  blk [%u]: ",obj);

   unsigned int vtmp = max_v + o[obj].range[0].vCount;
   if (vtmp > 65535) printf("[v overflow '%s'] ",tmp_m_dds[o[obj].texture]);
   if ((o[obj].texture == o[m_first].texture) && (vtmp <= 65535))
   {
   printf("merge into [%u]\n",m_first);
   max_v += o[obj].range[0].vCount;
   max_i += o[obj].range[0].iCount;
   m_last = obj;
   }
   else
   {
   printf("delayed\n");
   printf(" *blk %u completed: ",mix_numt);
   mix[mix_numt].texture = o[m_first].texture;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[o[m_first].texture])];
   mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[o[m_first].texture])];
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[o[m_first].texture]);
   strcpy(mix[mix_numt].m_shd,tmp_m_shd[o[m_first].texture]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   int i_pos=0, v_pos=0;
   for (unsigned int m = m_first; m <= m_last; m++)
   {
   memcpy(&mix[mix_numt].geom_vBlk[v_pos],o[m].geom_vBlk,sizeof(OGFVertex_v0)*o[m].range[0].vCount);
   memcpy(&mix[mix_numt].geom_iBlk[i_pos],o[m].geom_iBlk,sizeof(unsigned short)*o[m].range[0].iCount);

   if (i_pos) for (unsigned int ii = 0; ii < o[m].range[0].iCount; ii++)
   mix[mix_numt].geom_iBlk[i_pos+ii] += v_pos;

   v_pos += o[m].range[0].vCount;
   i_pos += o[m].range[0].iCount;

   }
   printf("max_v=%u, max_i=%u, v_pos=%u, i_pos=%u\n",max_v,max_i,v_pos,i_pos);
   mix_numt++;
   max_v = max_i = v_pos = i_pos = 0;
   obj = m_last;
   m_first = m_last + 1; m_last = m_first;
   }
   }

/////////////////////////

   // finish
   printf(" +blk %u completed: ",mix_numt);
   mix[mix_numt].texture = o[m_first].texture;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[o[m_first].texture])];
   mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[o[m_first].texture])];
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[o[m_first].texture]);
   strcpy(mix[mix_numt].m_shd,tmp_m_shd[o[m_first].texture]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   unsigned int i_pos=0, v_pos=0;
   for (unsigned int m = m_first; m <= m_last; m++)
   {
   memcpy(&mix[mix_numt].geom_vBlk[v_pos],o[m].geom_vBlk,sizeof(OGFVertex_v0)*o[m].range[0].vCount);
   memcpy(&mix[mix_numt].geom_iBlk[i_pos],o[m].geom_iBlk,sizeof(unsigned short)*o[m].range[0].iCount);

   if (i_pos) for (unsigned int ii = 0; ii < o[m].range[0].iCount; ii++)
   mix[mix_numt].geom_iBlk[i_pos+ii] += v_pos;
   }
   printf("max_v=%u, max_i=%u\n",mix_numt,v_pos,i_pos);
   mix_numt++;
#endif
//////////////////////////////////////////////////////////////////

  printf("parse complete\n");

  unsigned int tot_i = 0, tot_v = 0;

   for (i = 1; i < numtextures; i++)
    delete tmp_m_dds[i], delete tmp_m_lm_dds[i], delete tmp_m_shd[i];
   delete [] o;

///////////////////////////////////////
  printf("creating '%s'\n",fileName);
  outputFile = fopen(fileName,"wb");

  ChunkIFF * ih = new ChunkIFF;
  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  OGFHeader_v4 * hdr4 = new OGFHeader_v4;
  hdr4->format_version = 4;
  hdr4->type = 1;
  hdr4->shader_id = 0;
  // zero fill all :)
  hdr4->bs.r =
  hdr4->bs.c.x = 
  hdr4->bs.c.y = 
  hdr4->bs.c.z = 0.0f;
	hdr4->bb.min = hdr4->bb.max = hdr4->bs.c;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x12; // text info
  if (argc > 3) ih->size = 0x59 + strlen(intName); else ih->size = 0x6E; // guessed :)
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  i = 0; 
  if (argc > 3) 
  fprintf(outputFile,"%s.object",intName);
  else fputs("test_level\\test_level.object",outputFile);
  fwrite(&i,1,1,outputFile); 

  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time

  ih->type = 0x09; // childrens
  ih->size = 0;
	for (j = 0;j < mix_numt; j++)
	{
	if (lodsFlag) if (strstr(mix[j].m_dds,"prop_fake")) continue;
  ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(mix[j].m_dds) + strlen(mix[j].m_shd) + 0x02)+8)+(8+((mix[j].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((mix[j].iCount*2)+4));
  }

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  printf("making %u blocks\n",mix_numt);

	for (j = 0;j < mix_numt; j++)
	{
	if (lodsFlag) if (strstr(mix[j].m_dds,"prop_fake")) continue;

	// child start

  if (!mix[j].vCount) { printf(" blk: vCount is zero sized!!!\n"); continue; }
  if (!mix[j].iCount) { printf(" blk: iCount is zero sized!!!\n"); continue; }

  ih->type = j; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(mix[j].m_dds) + strlen(mix[j].m_shd) + 0x02)+8)+(8+((mix[j].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((mix[j].iCount*2)+4));

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	// .... 1.2.3.4

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb.min = hdr2.bb.min;
  hdr4->bb.max = hdr2.bb.max;
  // hdr4.bs ???
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x02; // texture
  ih->size = strlen(mix[j].m_dds) + strlen(mix[j].m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(mix[j].m_dds,outputFile); fwrite(&i,1,1,outputFile); 
  fputs(mix[j].m_shd,outputFile); fwrite(&i,1,1,outputFile); 

	tot_v+= mix[j].vCount;
  ih->type = 0x03; // verts
  ih->size = (mix[j].vCount*(sizeof(OGFVertex_v0)-8))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = mix[j].vCount;
  fwrite(&i,4,1,outputFile);
  for (unsigned int s = 0; s < i ; s++)
	fwrite(&mix[j].geom_vBlk[s],sizeof(OGFVertex_v0)-8,1,outputFile);
	
	tot_i+= mix[j].iCount;
  ih->type = 0x04; // idx
  ih->size = (mix[j].iCount*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = mix[j].iCount; 
  fwrite(&i,4,1,outputFile);
	fwrite(mix[j].geom_iBlk,sizeof(unsigned short),i,outputFile);

	printf("."); if ((j % 50)==0) printf("\r%u",j);
	// child end 
	}

  delete hdr4;
  delete ih;

  if (outputFile) fclose(outputFile);
  if (argc > 3) printf("\nwriting level '%s' to '%s' [v %u, i %u] OK\n",intName,fileName,tot_v,tot_i);
	else printf("\nwriting '%s' [v %u, i %u] OK\n",fileName,tot_v,tot_i);
///////////////////////////////////////

} // parseFlag == 2

	return 0;
	}
