#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE // MSVC 7.0 and later
#endif
#ifndef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS // MSVC 7.0 and later
#endif
#ifndef WINVER
#define WINVER 0x0400 // MFC need 4.0 or later
#endif

#ifdef USE_OS2
#define INCL_DOSPROCESS
#define INCL_DOSPROFILE
#include <os2.h>
#endif

#ifdef _WIN32
#include "windows.h"
#endif
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>

unsigned int numtextures,numiblocks,numiblocks2,numvblocks, numobjblocks;
unsigned char destFlag=0, parseFlag=0, lodsFlag = 0, lmapFlag = 0;
char defuser[] = "\\\\MSHOME\\Administrator";

struct vector3f
{
	float x,y,z; 
};

struct vector2f
{
	float tx,ty; 
};

#define VEC_Cross(a, b, c)((c).x = (a).y * (b).z - (a).z * (b).y, (c).y = (a).z * (b).x - (a).x * (b).z, (c).z = (a).x * (b).y - (a).y * (b).x)
#define VEC_Subtract(a, b, c)((c).x = (a).x - (b).x, (c).y = (a).y - (b).y, (c).z = (a).z - (b).z)
#define VEC_Magnitude(v)(sqrt((v).x * (v).x + (v).y * (v).y + (v).z * (v).z))
#define VEC_Normalizef(v){ float __mag = 1.0f / (float)VEC_Magnitude(v); \
(v).x *= __mag; (v).y *= __mag; (v).z *= __mag; }
void Make_Normal(vector3f a, vector3f b, vector3f c, vector3f * n)
{
	vector3f v1 = {0,0,0},v2 = {0,0,0};
	VEC_Subtract(b, a, v1);
	VEC_Subtract(c, a, v2);
	VEC_Cross(v1, v2, *n);
	VEC_Normalizef(*n);
}

struct lev_blk
{
	unsigned short type; // 1..8
	unsigned short fcomp; // compressed if = 32768
  unsigned int size;
};

struct lev_light  // 108 bytes
{
  int type0;
  int type1;
  float fRed;
  float fGreen;
  float fBlue;
  int unk[9];
  vector3f pos; // X,Z,Y
  vector3f rot; // X,Z,Y
  int unk1[2];
  float unk2[3];
  int unk3;
  float unk4;
};

struct lev_crown  // 18 bytes
{
  vector3f pos; // X,Z,Y
  float unk;
  short unk1;
};

struct ogf_bbox {
	struct vector3f		min;
	struct vector3f		max;
};

struct ogf_bsphere {
	struct vector3f		c;
	float			r;
};

struct cform_blk
{
  unsigned int version;
  unsigned int num_verts;
  unsigned int num_tris;
  ogf_bbox bb;
};

/*
struct tris_blk
{
 unsigned int tris[3];
 unsigned short matid; 
 unsigned short sec_num;
};
*/

struct VERTEXELEMENT9 // D3DVERTEXELEMENT9
{
	unsigned short Stream; 
	unsigned short Offset; 
	unsigned char Type;
/*
  D3DDECLTYPE_FLOAT1      = 0,
  D3DDECLTYPE_FLOAT2      = 1,
  D3DDECLTYPE_FLOAT3      = 2,
  D3DDECLTYPE_FLOAT4      = 3,
  D3DDECLTYPE_D3DCOLOR    = 4,
  D3DDECLTYPE_UBYTE4      = 5,
  D3DDECLTYPE_SHORT2      = 6,
  D3DDECLTYPE_SHORT4      = 7,
  D3DDECLTYPE_UBYTE4N     = 8,
  D3DDECLTYPE_SHORT2N     = 9,
  D3DDECLTYPE_SHORT4N     = 10,
  D3DDECLTYPE_USHORT2N    = 11,
  D3DDECLTYPE_USHORT4N    = 12,
  D3DDECLTYPE_UDEC3       = 13,
  D3DDECLTYPE_DEC3N       = 14,
  D3DDECLTYPE_FLOAT16_2   = 15,
  D3DDECLTYPE_FLOAT16_4   = 16,
  D3DDECLTYPE_UNUSED      = 17 
*/
	unsigned char Method;
	unsigned char Usage; 

// 0.12 - vertices (4*float) - X/Z/Y
// 3.4 - normales (4*(char-128)/128)
// 6.4 - binormales (4*(char-128)/128)
// 7.4 - tangent normales (4*(char-128)/128)
// 10.4 - ???? (4*char)
// 5.1 texcoords : (2*float)
// 5.6 texcoords : (2*short/1024)
// 5.7 texcoords : (2*short/2048) + dummy (4)
// 5.1.6 - lightmaps (2*short/32768)
	unsigned char UsageIndex; 
};

struct blk_12
{
 float xform[16];
 float c_scale_rgb[3];
 float c_scale_hemi;
 float c_scale_sun;
 float c_bias_rgb[3];
 float c_bias_hemi;
 float c_bias_sun;
};

struct blk_21
{
 unsigned int vBlkID;
 unsigned int vFirst;
 unsigned int vCount;
 unsigned int iBlkID;
 unsigned int iFirst;
 unsigned int iCount;
};

struct blk_07
{
 unsigned int vBlkID;
 unsigned int vFirst;
 unsigned int vCount;
};

struct blk_08
{
 unsigned int iBlkID;
 unsigned int iFirst;
 unsigned int iCount;
};

struct ChunkIFF
{
	unsigned int type, size;
};

struct OGFVertex_v0 // x-ray actor_editor (0x00000112)
{
	struct vector3f p;
	struct vector3f n;
	float u,v;
	float lu,lv;
};

struct OGFHeader_v4 // 0x2C (44)
{
 unsigned char format_version;
 unsigned char type;
 unsigned short shader_id;
 struct ogf_bbox		bb;
 struct ogf_bsphere	bs;
};

///////////////////////////////

#define MAX_OBJ_COUNT 30000
#define MAX_TXT_COUNT 1000

struct swidata {
  unsigned int m_reserved[4];
  unsigned int swicout;
};

struct slide_window {
	unsigned int		offset;
	unsigned short		num_tris;
	unsigned short		num_verts;
};

struct obj_blk // for ogf export
{
 unsigned short rangecount;
 unsigned char code;
 unsigned short texture;
 blk_21 range[2];
 OGFVertex_v0 * geom_vBlk;
 unsigned short * geom_iBlk;
/*
 OGFVertex_v0 * cform_vBlk;
 unsigned short * cform_iBlk;
*/
 char * m_dds;
 char * m_shd;
 char * m_lm_dds;
 float xform[16];
 struct ogf_bbox		bb;
 struct ogf_bsphere	bs;
 unsigned char dds_type;
#ifdef USE_LODS
 unsigned int lodcount;
 slide_window * lod;
#endif
 unsigned short swi;
};

obj_blk * o;
slide_window * swiblk;
unsigned short ocount = 0;
unsigned short orange = 0;
char * tmp_m_dds[MAX_TXT_COUNT];
char * tmp_m_shd[MAX_TXT_COUNT];
char * tmp_m_lm_dds[MAX_TXT_COUNT];

struct merged_blk
{
 OGFVertex_v0 * geom_vBlk;
 unsigned short * geom_iBlk;
 unsigned int iCount;
 unsigned int vCount;
 char * m_dds;
 char * m_shd;
 unsigned short texture;
};

#ifdef LINE_COMPACT
	 merged_blk mix[MAX_TXT_COUNT];
#else
	 merged_blk mix[MAX_TXT_COUNT*2];
#endif
///////////////////////////////


unsigned int memcmp_vec8(void * a, void * b) // 8 * 4(long) = 32
{
unsigned int * p0 = (unsigned int *)a;
unsigned int * p1 = (unsigned int *)b;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
p0++;p1++;
if (*p0 != *p1) return 1;
return 0;
}

int version;

float Dist3D(float x1, float y1, float z1, float x2, float y2, float z2)
{
	return (float)sqrt(((x1-x2)*(x1-x2)) + ((y1-y2)*(y1-y2)) + ((z1-z2)*(z1-z2)));
}

int DecodeChunk(lev_blk h,FILE *inputFile)
{
	printf(" DecodeChunk(0x%04X, 0x%08X)\n",h.type,h.size);

	if (h.fcomp == 0x8000) { printf("ERR: compressed block.\n"), _getch(); h.type = 0xFF; } // force_end

	if ((version >= 0x0A) && (version <= 0x0C)) // swap for earlier builds
	{
	if (h.type == 0x0A) h.type = 0x09; 
	else if (h.type == 0x09) h.type = 0x0A;
	}

	switch (h.type)
	{
	case 0x01: // level; level.geom, LEV_HEADER
  {
	fread(&version,h.size,1,inputFile);
	printf("  level version = 0x%08X\n",version);
	// only XRLC_0x0D, XRLC_0x0E (level+.cform+.geom)
	if (version < 0x0A) printf("unsupported version :(\n"), _getch();
	// 0x08 - bld 11xx, 0x09 - bld 1472, 0x0A - bld 1475, 0x0C - bld 1570-18xx, 2218
	return 1;
	}

	case 0x06: // level, LEV_LIGHTS
  {
	int numlights;
  numlights = h.size/108;
	// printf("  lights = %d\n",numlights);
	lev_light *ll = new lev_light[numlights];
	fread(ll,h.size,1,inputFile);
	if (!destFlag) for (int i = 0;i< numlights; i++)
	{
	printf("  light[%d]:%d:%d pos(%f,%f,%f) rot(%f,%f,%f)\n",i,
   ll[i].type0,ll[i].type1,
   ll[i].pos.x,ll[i].pos.z,ll[i].pos.y,
   ll[i].rot.x,ll[i].rot.z,ll[i].rot.y);
	}
	delete [] ll;
	return 1;
	}

	case 0x07: // level, LEV_CORONAS
  {
	int numcrowns;
  numcrowns = h.size/18;
	if (!destFlag) printf("  crowns = %d\n",numcrowns);
	lev_crown *lc = new lev_crown[numcrowns];
	fread(lc,h.size,1,inputFile);
  if (!destFlag) for (int i = 0;i< numcrowns; i++)
	{
	printf("  crown[%d]: pos(%f,%f,%f) %f %d\n",i,
   lc[i].pos.x,lc[i].pos.z,lc[i].pos.y,
   lc[i].unk,lc[i].unk1);
	} 
	delete [] lc;
	return 1;
	}

	case 0x02: // level, LEV_SHADERS
  {
	fread(&numtextures,4,1,inputFile);
	printf("  textures = %d\n",numtextures);
  if (numtextures > MAX_TXT_COUNT) printf("!!! too many textures, maximum is %u\n",MAX_TXT_COUNT), _getch();

	char *tmpdata = new char[h.size-4];
	fread(tmpdata,h.size-4,1,inputFile);
	unsigned int p=0, plen; p++; // skip #0
	for (unsigned int i = 1;i< numtextures; i++) // start from 1!!!,0 = zero texture!!!
	{
  if (!destFlag) printf("   [%d]: s,t,lmap0,lmap1 '%s'\n",i,&tmpdata[p]);

  plen = 0;
  while(tmpdata[p+plen] != 0x2F) plen++;
  tmp_m_shd[i] = new char[plen+1];
  memcpy(tmp_m_shd[i],&tmpdata[p],plen); tmp_m_shd[i][plen] = 0;
  p += plen; p++; 

  plen = 0;
  while((tmpdata[p+plen]) && (tmpdata[p+plen] != 0x2C)) plen++; //  != 0x00
  tmp_m_dds[i] = new char[plen+1];
  memcpy(tmp_m_dds[i],&tmpdata[p],plen); tmp_m_dds[i][plen] = 0;
  p += plen; 

  if (tmpdata[p] != 0x2C) goto no_lmap;
  p++; 

  plen = 0;
  while((tmpdata[p+plen]) && (tmpdata[p+plen] != 0x2C)) plen++; //  != 0x00
  tmp_m_lm_dds[i] = new char[plen+1];
  memcpy(tmp_m_lm_dds[i],&tmpdata[p],plen); tmp_m_lm_dds[i][plen] = 0;
	if (strstr(tmp_m_lm_dds[i],"lmap#")) tmp_m_lm_dds[i][plen-1] = '2'; // this is second lightmap ( i.e. lmap#?_2.dds )
  p += plen;

no_lmap:
  // printf("DDS:%s\nSHD:%s\nLM_DDS:%s\n",tmp_m_dds[i],tmp_m_shd[i],tmp_m_lm_dds[i]);

  while(tmpdata[p]) p++; //  != 0x00
  p++;

	}
	delete [] tmpdata;
	return 1;
	}

	case 0x03: // level, LEV_OBJECTS
  {
  unsigned int j, k, szBlk, szAll, szObj, idObj;
  szAll = h.size;
  while (szAll > 0)
  {
  ///
	fread(&idObj,4,1,inputFile);
	fread(&szObj,4,1,inputFile);
	if (!destFlag) printf("  [ OBJECT#%04d ] size %d\n",idObj,szObj);
  unsigned int i = 0, bdone = 0; 
  orange = 0;

	for (;;)
	{
	fread(&j,4,1,inputFile);
	fread(&szBlk,4,1,inputFile);  // size
  if (!destFlag) printf("   chunk = 0x%02X, size = %u\n",j,szBlk);

  if (j > 255) printf("!!! incorrect block (%u), it is an object start\n",j), _getch();
  if (ocount > MAX_OBJ_COUNT) printf("!!! too many objects, maximum is %u\n",MAX_OBJ_COUNT), _getch();

  switch(j)
  {

/*
  code = // OGF4 based
   0 - 21,22,1 or 21,1 or 21,22,21,1 // MT4_NORMAL, brush
   1 - 1,10 // MT4_HIERRARHY, brush+entity
   2 - 21,6,22,1 or 21,6,1 or 21,6,22,21,6,1 // MT4_PROGRESSIVE, entity
   6 - 1,10,11 // MT4_LOD, greens joined
   7 - 21,12,1 // MT4_TREE_ST, greens
   B - 21,1,12,6 or 21,12,1,20 // MT4_TREE_PM, greens scaled

 subcode

 21, 22 - geom - ib,vb
  1 - base, pos(x,y,z) 
 10 - merged data ???
 11 - green  
 12 - green placement ???
 20 - swidata
*/

  case 1: 
  {
  OGFHeader_v4 hdr;
	fread(&hdr,sizeof(OGFHeader_v4),1,inputFile);
  if (!destFlag) printf("    MT4_HEAD: type 0x%02X sh_id %d bs.c(%f,%f,%f), size = %u\n",
    hdr.type,hdr.shader_id,hdr.bs.c.x,hdr.bs.c.y,hdr.bs.c.z,szBlk);
   if (destFlag) 
   if (orange) // we don't need 'no i/v objects!'
   {
   o[ocount].code = hdr.type;
   o[ocount].texture = hdr.shader_id;
   o[ocount].bb = hdr.bb;
   o[ocount].bs = hdr.bs;
   }
   if (hdr.type == 0x00) bdone = 1;
   else
   if (hdr.type == 0x01) bdone = 10;
   else
   if (hdr.type == 0x02) bdone = 1;
   else
   if (hdr.type == 0x06) bdone = 11;
   else
   if (hdr.type == 0x07) bdone = 1;
   else
   if (hdr.type == 0x0B) bdone = 20;
   else
   printf("!!! unknown object (0x%02X) !!!\n",hdr.type), _getch();

  i += szBlk;
	break;
  }

  case 20: 
  {
  unsigned int swi;
	fread(&swi,4,1,inputFile);
  if (!destFlag) printf("    MT4_SWICNTR = %u, size = %u\n",swi,szBlk);
  else o[ocount].swi = (unsigned short)swi;
  i += szBlk;
	break;
  }

  case 7: 
  {
  blk_07 iv;
	fread(&iv,sizeof(blk_07),1,inputFile);
   if (!destFlag)  printf("    OGF4_VCONTAINER: (v:#%d,%d,%d), size = %u\n",
    iv.vBlkID,iv.vFirst,iv.vCount,szBlk);
  else
  {
  o[ocount].range[orange].vBlkID = iv.vBlkID;
  o[ocount].range[orange].vFirst = iv.vFirst;
  o[ocount].range[orange].vCount = iv.vCount;
  }
  i += szBlk;
	break;
  }

  case 8: 
  {
  blk_08 iv;
	fread(&iv,sizeof(blk_08),1,inputFile);
   if (!destFlag)  printf("    OGF4_ICONTAINER: (i:#%d,%d,%d), size = %u\n",
    iv.iBlkID,iv.iFirst,iv.iCount,szBlk);
  else
  {
  o[ocount].range[orange].iBlkID = iv.iBlkID;
  o[ocount].range[orange].iFirst = iv.iFirst;
  o[ocount].range[orange].iCount = iv.iCount;
  o[ocount].swi = 65535; // hack
#ifdef USE_LODS
  if (orange == 0) o[ocount].lodcount = 0;
#endif
  orange++;
  }
  i += szBlk;
	break;
  }

  case 21: 
  {
  blk_21 iv;
	fread(&iv,sizeof(blk_21),1,inputFile);
   if (!destFlag)  printf("    OGF4_GCONTAINER: (v:#%d,%d,%d) (i:#%d,%d,%d), size = %u\n",
    iv.vBlkID,iv.vFirst,iv.vCount,iv.iBlkID,iv.iFirst,iv.iCount,szBlk);
  else
  {
  o[ocount].range[orange].vBlkID = iv.vBlkID;
  o[ocount].range[orange].vFirst = iv.vFirst;
  o[ocount].range[orange].vCount = iv.vCount;
  o[ocount].range[orange].iBlkID = iv.iBlkID;
  o[ocount].range[orange].iFirst = iv.iFirst;
  o[ocount].range[orange].iCount = iv.iCount;
  o[ocount].swi = 65535; // hack
#ifdef USE_LODS
  if (orange == 0) o[ocount].lodcount = 0;
#endif
  orange++;
  }
  i += szBlk;
	break;
  }

  case 22: 
  {
  if (!destFlag) printf("    OGF4_FASTPATH: %u\n",szBlk); // cform_header
  i += szBlk;
	break;
  }

  case 6: 
  {
  if (!destFlag) printf("    OGF4_SWIDATA, len: %d\n",szBlk); // LODS
  swidata s;
	fread(&s,sizeof(swidata),1,inputFile);
#ifdef USE_LODS
  if (!destFlag) printf("    swi[%u] = swicnt = %u\n",0,s.swicout);
  else
  {
  if (orange < 2)
  {
  printf("    *obj[%u].type[0x%02X].lodcount = %u\n",ocount,o[ocount].code, s.swicout);
  o[ocount].lodcount = s.swicout;
  o[ocount].lod = new slide_window[s.swicout];
	fread(o[ocount].lod,sizeof(slide_window),s.swicout,inputFile);
	}
	else
	{
  printf("    *read rest...\n");
  unsigned int m = sizeof(slide_window)*s.swicout;
	char *tmpdata = new char[m];
  fread(tmpdata,m,1,inputFile); // dummy read rest
  delete [] tmpdata;
	}
	}
#else
  slide_window sw;
	fread(&sw,sizeof(slide_window),1,inputFile);
	sw.num_tris *= 3; // tris to idx
  if (!destFlag) printf("    swi[0 of %u] = sz %u, off %u\n",s.swicout,sw.num_tris,sw.offset);
  else
  {
  printf("    *obj[%u].type[0x%02X].range[%u].swi[0] = sz %u -> %u, off %u\n",ocount, o[ocount].code,orange-1,o[ocount].range[orange-1].iCount,sw.num_tris,sw.offset);
	o[ocount].range[orange-1].iFirst += sw.offset;
  o[ocount].range[orange-1].iCount = sw.num_tris;
  }
  unsigned int m = szBlk-sizeof(swidata)-sizeof(slide_window);
	char *tmpdata = new char[m];
  fread(tmpdata,m,1,inputFile); // dummy read rest
  delete [] tmpdata;
#endif
  if ((i + szBlk) > szObj) szBlk = 8; // , printf("!!! blk#6: overflow fixed\n");
  i += szBlk;
	break;
  }

  case 10: 
  {
  unsigned int cnt, ob;
	fread(&cnt,4,1,inputFile);
  if (!destFlag) printf("    OGF4_CHILDREN_L, size = %d, objcnt = %u\n",szBlk,cnt);
  for (unsigned int m = 0; m < cnt; m++) { fread(&ob,4,1,inputFile);  } // printf(" %u",ob);
  i += (szBlk + 16);
  //printf("!!! blk#10: advance 16 bytes, rest = %u\n",szBlk-4-(cnt*4));
	break;
  }

  case 12: 
  {
  blk_12 iv;
	fread(&iv,sizeof(blk_12),1,inputFile);
  if (!destFlag)  printf("    OGF4_TREEDEF2: xform[16] matrix, size = %u\n", szBlk); 
  else memcpy(&o[ocount].xform,&iv,16*sizeof(float));
  i += szBlk;
	break;
  }

  case 11: 
  case 24: 
  default:
  {
  if (!destFlag)  printf("    undef_chunk[0x#%02X], len: %d\n",j,szBlk);
  for (unsigned int m = 0; m < szBlk; m++) fread(&k,1,1,inputFile); // dummy read szBlk times
  i += szBlk;
	break;
  }

  } // end of switch

  // printf("    size check (i=%u ? szObj=%u)\n", i, szObj);

  if (i == szObj)
  {
  if (!destFlag) printf("    object completed\n");
  break;
  }

  if ((bdone == j) && (i < szObj) && ((szObj - i) <= 32)) // read all the rest and break
  {
  if (!destFlag) printf("    object completed (forced EOO [%u - %u = %u])\n",szObj,i,szObj - i);
  break;
  }

  if (j == 0x14) // read all the rest and break after chunk(0x14)
  {
  if (!destFlag) printf("    null_object completed (forced EOO [%u - %u = %u])\n",szObj,i,szObj - i);
  break;
  }

  if (i > szObj) { printf("obj ended beyond limit (i %d szobj %d).\n",i,szObj); break;  }

	}

  if (destFlag) 
  {
  o[ocount].rangecount = orange;

  if (orange) 
  {
	if ((o[ocount].code == 0x00) || (o[ocount].code == 0x02))
  ocount++; 
  if (((o[ocount].code == 0x07) || (o[ocount].code == 0x0B)) && (!lodsFlag))
  ocount++; 
  }

  orange = 
  o[ocount].rangecount =
  o[ocount].code = 0;
  o[ocount].texture = 0;
  }

  szAll -= szObj;
  szAll -= 8;

	} ///

	return 1;
	}

	case 0x09: // level.geom, LEV_V_BLOCKS
  {
  int dummy32, tot_vblks = 0;
  VERTEXELEMENT9 v_e[10];

	fread(&numvblocks,4,1,inputFile);
	printf("  numvblocks = %d\n",numvblocks);


	for (unsigned int cnt=0;cnt<numvblocks;cnt++) // base header
	{
  printf("    vBlock[%u]\n",cnt); // start
  unsigned short ccnt = 0;
	for (;;) // header of vblock
	{
  if (ccnt >= 10) { printf("!!!! max sz = 10 reached\n"); _getch(); }
	fread(&v_e[ccnt],4,1,inputFile); //	stream #
	if (v_e[ccnt].Stream == 255) break; // end
	fread(&v_e[ccnt].Type,sizeof(VERTEXELEMENT9)-4,1,inputFile);
	// printf("     Stream:%d Offset:%d Type:%d Usage:%d UsageIndex:%d\n",v_e[ccnt].Stream, v_e[ccnt].Offset,v_e[ccnt].Type,v_e[ccnt].Usage,v_e[ccnt].UsageIndex);
	ccnt++;
	}

	fread(&dummy32,4,1,inputFile);
	// if (dummy32 == 17) printf("      [+] vert_blk_start\n");
	fread(&dummy32,4,1,inputFile); // printf("       vert_blks: %d [ ... ]\n", dummy32 );
  tot_vblks += dummy32;

   OGFVertex_v0 * v_tmp = new OGFVertex_v0[dummy32];
   char * v_tmp_type = new char[dummy32];

   for (int  i = 0;i < dummy32;i++)
   {
   vector2f v5;
   short s16;
   unsigned char u8;
   float f4[4], uadd=0, vadd=0;

 	 v_tmp_type[i] = 0; // i.e. texture.dds

   for (int dcnt = 0;dcnt < ccnt;dcnt++)
   {
/*
   if (!destFlag)
		if (v_e[dcnt].Usage != 0) // p
		if (v_e[dcnt].Usage != 3) // n
		if (v_e[dcnt].Usage != 6) // t
		if (v_e[dcnt].Usage != 7) // b
    if (v_e[dcnt].UsageIndex != 1) // lm
	  printf("* t/m/u/i %u:%u:%u:%u = ",
		v_e[dcnt].Type,v_e[dcnt].Method,v_e[dcnt].Usage,
	  v_e[dcnt].UsageIndex);
*/
   switch(v_e[dcnt].Type) // D3DDECLTYPE
   {
   case 1: // D3DDECLTYPE_FLOAT2
   {
 	 fread(&f4,sizeof(float),2,inputFile); 
 	 f4[2] = 0.0f; f4[3] = 1.0f;
 	 break;
 	 }
   case 2: // D3DDECLTYPE_FLOAT3
   {
 	 fread(&f4,sizeof(float),3,inputFile); 
 	 f4[3] = 1.0f;
 	 break;
 	 }
   case 4: // D3DDECLTYPE_D3DCOLOR
   {
 	 fread(&u8,1,1,inputFile); f4[0] = (float)u8;
 	 fread(&u8,1,1,inputFile); f4[1] = (float)u8;
 	 fread(&u8,1,1,inputFile); f4[2] = (float)u8;
 	 fread(&u8,1,1,inputFile); f4[3] = (float)u8;
 	 break;
 	 }
   case 6: // D3DDECLTYPE_SHORT2
   {
 	 fread(&s16,2,1,inputFile); f4[0] = (float)s16;
 	 fread(&s16,2,1,inputFile); f4[1] = (float)s16; 
 	 break;
 	 }
   case 7: // D3DDECLTYPE_SHORT4
   {
 	 fread(&s16,2,1,inputFile); f4[0] = (float)s16;
 	 fread(&s16,2,1,inputFile); f4[1] = (float)s16;
 	 fread(&s16,2,1,inputFile); f4[2] = (float)s16;
 	 fread(&s16,2,1,inputFile); f4[3] = (float)s16;
 	 break;
 	 }
   default: printf("should not get here, D3D9VE.Type: %u\n",v_e[dcnt].Type); _getch(); break;
 	 }

   switch(v_e[dcnt].Method) // D3DDECLMETHOD
   {
   case 0: break; // D3DDECLMETHOD_DEFAULT
   default: printf("should not get here, D3D9VE.Method: %u\n",v_e[dcnt].Method); _getch(); break;
 	 }

   switch(v_e[dcnt].Usage) // D3DDECLTYPE
   {
   case 0: // D3DDECLUSAGE_POSITION
   {
 	 // if (!destFlag) printf("position[%d](X,Y,Z) = %f,%f,%f\n",i,f4[0],f4[1],f4[2]);
   v_tmp[i].p.x = f4[0]; v_tmp[i].p.y = f4[1]; v_tmp[i].p.z = f4[2];
   break;
   }
   case 3: // D3DDECLUSAGE_NORMAL, W component is ambient occlusion (float)
   {
 	 v_tmp[i].n.z = (f4[0] - 127.5f) / 127.5f;
	 v_tmp[i].n.y = (f4[1] - 127.5f) / 127.5f; 
   v_tmp[i].n.x = (f4[2] - 127.5f) / 127.5f;
	 // if (!destFlag) printf("normal[%d](X,Y,Z,W) = %f,%f,%f,%f\n",i,f4[0],f4[1],f4[2],f4[3]);
 	 // printf(" AOCC is %f\n",f4[3]);
   break;
   }
   case 6: // D3DDECLUSAGE_TANGENT
   {
	 // if (!destFlag) printf("tangent[%d](X,Y,Z,W) = %f,%f,%f,%f\n",i,f4[0],f4[1],f4[2],f4[3]);
   uadd = f4[3] / 255.0f;
   break;
   }
   case 7: // D3DDECLUSAGE_BINORMAL
   {
	 // if (!destFlag) printf("binormal[%d](X,Y,Z,W) = %f,%f,%f,%f\n",i,f4[0],f4[1],f4[2],f4[3]);
   vadd = f4[3] / 255.0f;
   break;
   }
   case 10: // D3DDECLUSAGE_COLOR
   {
	 // if (!destFlag) printf("color[%d](X,Y,Z,W) = %f,%f,%f,%f\n",i,f4[0],f4[1],f4[2],f4[3]);
   break;
   }
   case 5: // D3DDECLUSAGE_TEXCOORD
   {

	 if (v_e[dcnt].UsageIndex == 0)
	 {
   if (v_e[dcnt].Type == 1) // 221x levels has this type
   {
 	 // if (!destFlag) printf("texcoord[%d](U,V) = %f,%f\n",i,f4[0],f4[1]);
   v_tmp[i].u = f4[0];
   v_tmp[i].v = f4[1];
   }
   else if (v_e[dcnt].Type == 6) // D3DDECLTYPE_SHORT2
	// #6 used for lod statics, i.e. non 0x07, 0x0B objects
   {
 	 v5.tx = (f4[0] + uadd) / 1024.0f;
 	 v5.ty = (f4[1] + vadd) / 1024.0f;
 	 //printf(" tc add = %f+%f,%f+%f (static)\n",f4[0],uadd,f4[1],vadd);
	 // if (!destFlag) printf("texcoord[%d](U,V) = %f,%f\n",i,v5.tx,v5.ty);
   v_tmp[i].u = v5.tx;
   v_tmp[i].v = v5.ty;
   }
   else if (v_e[dcnt].Type == 7) // D3DDECLTYPE_SHORT4
	// #7 used for "placeable" lod statics, i.e. 0x07, 0x0B objects
   {
 	 v5.tx = f4[0] / 2048.0f; // ????
 	 v5.ty = f4[1] / 2048.0f; // ????
	 // if (!destFlag) printf("texcoord[%d](U,V) = %f,%f\n",i,v5.tx,v5.ty);
   v_tmp[i].u = v5.tx;
   v_tmp[i].v = v5.ty;
   }
   }
   else if (v_e[dcnt].UsageIndex == 1) // _lmap_
	 {
   if (v_e[dcnt].Type == 6) // D3DDECLTYPE_SHORT2
   // used for statics, i.e. non 0x07, 0x0B objects
   {
 	 v5.tx = f4[0] / 32768.0f;
 	 v5.ty = f4[1] / 32768.0f;
	 // if (!destFlag) printf("lmapcoord[%d](U,V) = %f,%f\n",i,v5.tx,v5.ty);
   v_tmp[i].lu = v5.tx;
   v_tmp[i].lv = v5.ty;
	 if (lmapFlag) v_tmp_type[i] = 1; // i.e. texture_lm.dds, uncomment to enable lmaps :)
   }
   else
	 { printf("should not get here, D3D9VE.Type: %u\n",v_e[dcnt].Type); _getch(); break; }
   } // lmap end

   break;
   }

   default: printf("should not get here, D3D9VE.Usage: %u\n",v_e[dcnt].Usage); _getch(); break;
   }
   }
   // printf("press a key to break\n"); _getch();
   }
/////////////////////////
   if (destFlag) for (unsigned int obj = 0; obj < ocount; obj++)
   if (o[obj].range[0].vBlkID == cnt) 
   {
   unsigned int bsz = o[obj].range[0].vCount;
   unsigned int bst = o[obj].range[0].vFirst;
   o[obj].dds_type = v_tmp_type[bst]; // differ lmap - dds
   o[obj].geom_vBlk = new OGFVertex_v0[bsz];
   memcpy(o[obj].geom_vBlk,&v_tmp[bst],sizeof(OGFVertex_v0)*bsz);
	 if (!lodsFlag) if ((o[obj].code == 0x0B) || (o[obj].code == 0x07))
   for (unsigned int q = 0; q < bsz; q++)
   {
   float x,y,z;
   x = o[obj].geom_vBlk[q].p.x;
   y = o[obj].geom_vBlk[q].p.y;
   z = o[obj].geom_vBlk[q].p.z;
	o[obj].geom_vBlk[q].p.x = o[obj].xform[0]*x + o[obj].xform[4]*y + o[obj].xform[8]*z + o[obj].xform[12]*1;
	o[obj].geom_vBlk[q].p.y = o[obj].xform[1]*x + o[obj].xform[5]*y + o[obj].xform[9]*z + o[obj].xform[13]*1;
	o[obj].geom_vBlk[q].p.z = o[obj].xform[2]*x + o[obj].xform[6]*y + o[obj].xform[10]*z + o[obj].xform[14]*1;
	o[obj].geom_vBlk[q].p.x += o[obj].xform[3];
	o[obj].geom_vBlk[q].p.y += o[obj].xform[7];
	o[obj].geom_vBlk[q].p.z += o[obj].xform[11];

#ifndef USE_NZYX
	o[obj].geom_vBlk[q].n.x = 2.0f; // mark as bad
#else
  x = o[obj].geom_vBlk[q].n.x;
  y = o[obj].geom_vBlk[q].n.y;
  z = o[obj].geom_vBlk[q].n.z;
	o[obj].geom_vBlk[q].n.x = o[obj].xform[0]*x + o[obj].xform[4]*y + o[obj].xform[8]*z;
	o[obj].geom_vBlk[q].n.y = o[obj].xform[1]*x + o[obj].xform[5]*y + o[obj].xform[9]*z;
	o[obj].geom_vBlk[q].n.z = o[obj].xform[2]*x + o[obj].xform[6]*y + o[obj].xform[10]*z;
#endif
   }
   }
/////////////////////////

  delete [] v_tmp;
  delete [] v_tmp_type;
	//printf("press a key to break\n"); _getch();
	}
  printf("    tot_vert_blks: %d\n", tot_vblks );
	return 1;
	}

	case 0x0A: // level.geom, LEV_I_BLOCKS
  {
  unsigned short ii; unsigned int tot_f = 0, tot_i = 0;
	fread(&numiblocks,4,1,inputFile);
	printf("  numiblocks = %d\n",numiblocks);
	for (unsigned int i = 0;i< numiblocks; i++)
	{
	fread(&numiblocks2,4,1,inputFile);
	unsigned short * i_tmp = new unsigned short[numiblocks2];
	printf("  iBlock[%d]: '%d faces, %d indexes'\n",i,numiblocks2/3,numiblocks2);
  tot_f += (numiblocks2/3); tot_i += numiblocks2;
	fread(i_tmp,sizeof(unsigned short),numiblocks2,inputFile);

/////////////////////////
   if (destFlag) 
   for (ii = 0; ii < ocount; ii++)
   if (o[ii].range[0].iBlkID == i) 
   {
   unsigned int bsz = o[ii].range[0].iCount;
   unsigned int bst = o[ii].range[0].iFirst;
   o[ii].geom_iBlk = new unsigned short[bsz];
   memcpy(o[ii].geom_iBlk,&i_tmp[bst],sizeof(unsigned short)*bsz);
   }
/////////////////////////

  delete [] i_tmp;
	}
	printf("  totals: '%d faces, %d indexes'\n",tot_f,tot_i);

/////////////////////////
   if ((destFlag) && (version < 13))
   {
   printf("    *reversed!\n");
   for (ii = 0; ii < ocount; ii++) 
   {
   if (o[ii].swi != 65535) // .swi filled
   printf("    *obj[%u].type[0x%02X]: sz %u -> %u\n",ii, o[ii].code, o[ii].range[0].iCount,swiblk[o[ii].swi].num_tris),
   o[ii].range[0].iCount = swiblk[o[ii].swi].num_tris,
	 memcpy(o[ii].geom_iBlk,
   &o[ii].geom_iBlk[swiblk[o[ii].swi].offset],swiblk[o[ii].swi].num_tris*sizeof(unsigned short)); // hack
   }
   delete [] swiblk;
   }
/////////////////////////

	return 1;
	}

	case 0x0B: // level.geom, SWIDATA, i.e. LODS (for 0x07, 0x0B)
  {
    unsigned short ii; 
	  unsigned int swcnt;
		fread(&swcnt,4,1,inputFile);
		printf("  numswiblocks = %d\n",swcnt);
		if (!swcnt) return 1;
    swidata s;
#ifdef USE_LODS
		for (unsigned int i = 0;i < swcnt; i++)
		{
		fread(&s,sizeof(swidata),1,inputFile);
    slide_window * sw = new slide_window[s.swicout];
		fread(sw,sizeof(slide_window),s.swicout,inputFile);

	  if (destFlag) 
	  {
    printf("  *match for swi[%u] = %u blocks ?\n",i,s.swicout);
 	  for (ii = 0; ii < ocount; ii++) 
 	  {
	  if (o[ii].swi == i) // match
	  {
    printf("    *obj[%u].type[0x%02X]: sz %u OK\n",ii, o[ii].code, o[ii].range[0].iCount),
    o[ii].lodcount = s.swicout;
	  o[ii].lod = new slide_window[s.swicout];
		memcpy(o[ii].lod,sw,sizeof(slide_window)*s.swicout);
    }
    }
    }
    delete [] sw;
		}
#else
    slide_window sw;
    swiblk = new slide_window[swcnt];
		for (unsigned int i = 0;i < swcnt; i++)
		{
		fread(&s,sizeof(swidata),1,inputFile);
		fread(&sw,sizeof(slide_window),1,inputFile);
    swiblk[i].num_tris = sw.num_tris*3;
    swiblk[i].offset = sw.offset;
    printf("    swi[%u] = sz %u / off %u, swicnt = %u\n",i,swiblk[i].num_tris,swiblk[i].offset,s.swicout);
		for (unsigned int j = 0;j < (s.swicout-1); j++) 
			fread(&sw,sizeof(slide_window),1,inputFile); // read rest
		}

   if ((destFlag) && (o[0].geom_iBlk != NULL))
	 {
   for (ii = 0; ii < ocount; ii++) 
   {
   if (o[ii].swi != 65535) // .swi filled
   printf("    *obj[%u].type[0x%02X]: sz %u -> %u\n",ii, o[ii].code, o[ii].range[0].iCount,swiblk[o[ii].swi].num_tris),
   o[ii].range[0].iCount = swiblk[o[ii].swi].num_tris,
	 memcpy(o[ii].geom_iBlk,
   &o[ii].geom_iBlk[swiblk[o[ii].swi].offset],swiblk[o[ii].swi].num_tris*sizeof(unsigned short)); // hack
   }
   if (o[0].geom_iBlk != NULL) delete [] swiblk;
   }
#endif
		return 1;}

	case 0x05: // level
	case 0x08: // level, LEV_SECTORS
	case 0x0E: // ??????????
  case 0x04: // level, LEV_PORTALS
  case 0xFF: // forced_end
  {
		//printf("  UNKNOWN LEV_BLK = %d\n",h.type); 
    //_getch();
		char *tmpdata = new char[h.size];
		fread(tmpdata,h.size,1,inputFile);
		delete [] tmpdata;
		return 0;}
	default: { printf("unknown lev_blk = %d\n",h.type); return 0;}
	}
}

#ifdef _WIN32
static LARGE_INTEGER FPSCount0={0,0}, FPSCount1={0,0};
static LARGE_INTEGER CounterFrequency={0,0};
#endif
#ifdef USE_OS2
static ULONG CounterFrequency;
static QWORD FPSCount0={0,0}, FPSCount1={0,0}; 
#endif

int main(int argc, char* argv[])
{
  lev_blk hdr;
  cform_blk hdr2;
  unsigned int i, fullsize=0, j;
	char fileName[256], intName[256];
	unsigned char mainFlag = 0;
  FILE *inputFile, *outputFile;
#ifdef _WIN32
	//DWORD PriorityClass = GetPriorityClass(GetCurrentProcess());
	SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS); // REALTIME_PRIORITY_CLASS
	QueryPerformanceFrequency(&CounterFrequency);
	QueryPerformanceCounter(&FPSCount0);
#endif
#ifdef USE_OS2
	DosTmrQueryFreq(&CounterFrequency);
	DosTmrQueryTime(&FPSCount0);
#endif

 	printf("X-Ray level (2xxx+) parser-converter [201212xx]\n");

	if (argc < 2) 
  {
  	printf("usage: parse_lev < mode > [ destfile.ogf ] [ internal_name ]\n\tmode: 0/1 - conv: normal/optimized, 0/2 - lods_fake/no_lods_fake,\n\t0/4 - no_lmap/lmap, 0/8 - convert/dump only\n\tdestfile.ogf: destination file (modes 0-7 only)\n\tinternal_name: internal model name\n");
		return 1;
	}

  mainFlag = (char)atoi(argv[1]);

  parseFlag = mainFlag & 1;
  lodsFlag = mainFlag & 2;
  lmapFlag = mainFlag & 4;

	if (mainFlag < 8) 
	{
  if (argc < 3) 
  {
		printf("X-Ray PARSE_LEV: no arguments given in mode(s) 0 - 7.\n"); return 1;
  }
  else strcpy((char*)fileName,argv[2]), destFlag = 1;
  }
  if (argc > 3) strcpy((char*)intName,argv[3]);

  if (destFlag) o = new obj_blk[MAX_OBJ_COUNT];

  inputFile = fopen("level","rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open 'level'.\n");
  return 1;
  }
  printf("------------------------------\nLoading spatial-DB (level)...\n");
	fseek(inputFile,0,SEEK_END);
  fullsize = ftell(inputFile);
	fseek(inputFile,0,SEEK_SET);
  while(fullsize)
  {
  fread( &hdr, sizeof(lev_blk), 1, inputFile );
  printf("Type 0x%04X, compress 0x%04X, size %d\n",hdr.type,hdr.fcomp,hdr.size);
  DecodeChunk(hdr,inputFile);
  fullsize -= hdr.size; fullsize -= 8;
	}
  fclose(inputFile);
  printf("loading OK\n");


  if (version >= 13) 
  {
  inputFile = fopen("level.geom","rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open 'level.GEOM'.\n");
  return 1;
  }
  printf("------------------------------\nLoading geometry (level.GEOM)...\n");
	fseek(inputFile,0,SEEK_END);
  fullsize = ftell(inputFile);
	fseek(inputFile,0,SEEK_SET);
  while(fullsize)
  {
  fread( &hdr, sizeof(lev_blk), 1, inputFile );
  printf("Type 0x%04X, compress 0x%04X, size %d\n",hdr.type,hdr.fcomp,hdr.size);
  DecodeChunk(hdr,inputFile);
  fullsize -= hdr.size; fullsize -= 8;
	}
  fclose(inputFile);
  printf("loading OK\n");
  }

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

  inputFile = fopen("level.cform","rb");
	if(!inputFile)
  {
	goto no_cform;
 	//printf("WARN: cannot open 'level.CFORM'.\n");
  }
  printf("------------------------------\nLoading CFORM (level.CFORM)...\n");

  fread( &hdr2, sizeof(cform_blk), 1, inputFile );
  printf(" version 0x%08X, verts %d faces %d,\n bb(%f,%f,%f)-(%f,%f,%f)\n",
  hdr2.version,hdr2.num_verts,hdr2.num_tris,
  hdr2.bb.min.x,hdr2.bb.min.y,hdr2.bb.min.z,hdr2.bb.max.x,hdr2.bb.max.y,hdr2.bb.max.z);
/*
	vector3f *v = new vector3f[hdr2.num_verts];
	fread(v,sizeof(vector3f),hdr2.num_verts,inputFile);
	tris_blk *idx = new tris_blk[hdr2.num_tris];
	fread(idx,sizeof(tris_blk),hdr2.num_tris,inputFile);

///////////////////////////
   for (unsigned int obj = 0; obj < ocount; obj++)
   if (o[obj].rangecount == 2) 
   {
   printf("cform match with obj=%u\n",obj);

   unsigned int vsz = o[obj].range[1].vCount;
   unsigned int vst = o[obj].range[1].vFirst;
   unsigned int isz = o[obj].range[1].iCount / 3;
   unsigned int ist = o[obj].range[1].iFirst / 3;

   o[obj].cform_vBlk = new OGFVertex_v0[vsz];
   for (unsigned int b = 0; b < vsz; b++) o[obj].cform_vBlk[b].p = v[vst+b];

   o[obj].cform_iBlk = new unsigned short[isz*3];
   unsigned int b0 = 0; for (b = 0; b < isz; b++) 
   {
   //o[obj].cform_iBlk[b0] = idx[ist+b].tris[0]; // x,y,z
   //o[obj].cform_iBlk[b0+1] = idx[ist+b].tris[1];
   //o[obj].cform_iBlk[b0+2] = idx[ist+b].tris[2];
   b0 += 3;
   }
   }
///////////////////////////
  delete [] v;
  delete [] idx;
*/
  fclose(inputFile);
  printf("loading OK\n");
no_cform:

//////////////////////////////////////////////////////////////////
//////// check for stage #1
//////////////////////////////////////////////////////////////////


OGFVertex_v0 * tmp_v; //, * tmp_v2, * tmp_v3;
unsigned short * tmp_i;
//int dupcnt = 0;
for (i = 0; i < ocount;i++)
{
tmp_v = new OGFVertex_v0[o[i].range[0].vCount];
tmp_i = new unsigned short[o[i].range[0].iCount];
/*
printf("\rtesting ... ");
tmp_v3 = o[i].geom_vBlk;
for (j=0; j < o[i].range[0].vCount; j++)
{
tmp_v2 = o[i].geom_vBlk;
for (unsigned int k=0; k < o[i].range[0].vCount; k++)
{
if (k > j)
{
if (memcmp_vec8(tmp_v3,tmp_v2) == 0) dupcnt++; // printf ("*"), 
}
tmp_v2++;
}
tmp_v3++;
}
*/
printf("\rcompacting mesh %05u of %05u ...",i,ocount);

  OGFVertex_v0 * tmp_v_src = o[i].geom_vBlk;
	unsigned short * tmp_i_src = o[i].geom_iBlk;
	unsigned int cnt = 0, c;

	for (c = 0; c < o[i].range[0].iCount;c++)
	{
  OGFVertex_v0 * p1 = &tmp_v_src[tmp_i_src[c]];
	for (unsigned int r = 0; r < cnt; r++)
	{
  if (memcmp_vec8(&tmp_v[r],p1) == 0) { tmp_i[c] = r; goto stage2; }
	}
  tmp_v[cnt] = *p1; tmp_i[c] = cnt; cnt++;
	if (cnt >= 65535) break;
stage2:;
	}
	o[i].range[0].vCount = cnt;
	o[i].range[0].iCount = c;
	memcpy(o[i].geom_vBlk,tmp_v,sizeof(OGFVertex_v0) * cnt);
	memcpy(o[i].geom_iBlk,tmp_i,sizeof(unsigned short) * c);
	delete [] tmp_v;
	delete [] tmp_i;
}
/*
printf("\nSTAGE#1: total dups %u, economy %u\n",dupcnt,dupcnt*(sizeof(OGFVertex_v0)-8));

//////////////////////////////////////////////////////////////////
//////// check for dups stage #2
//////////////////////////////////////////////////////////////////

dupcnt = 0;
for (i = 0; i < ocount;i++)
{
printf("\rtesting mesh %05u of %05u ...",i,ocount);
tmp_v = o[i].geom_vBlk;
for (j=0; j < o[i].range[0].vCount; j++)
{
tmp_v2 = o[i].geom_vBlk;
for (unsigned int k=0; k < o[i].range[0].vCount; k++)
{
if (k > j)
{
if (memcmp_vec8(tmp_v,tmp_v2) == 0) dupcnt++; // printf ("*"), 
}
tmp_v2++;
}
tmp_v++;
}
}
printf("\nSTAGE#2: total dups %u, economy %u\n",dupcnt,dupcnt*(sizeof(OGFVertex_v0)-8)); // _getch();

//////////////////////////////////////////////////////////////////
//////// check for dups
//////////////////////////////////////////////////////////////////
*/

  if (!destFlag) return 0;

if (parseFlag == 0) 

{
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

	 unsigned short numblocks = 0; unsigned int obj;

   for (obj = 0; obj < ocount; obj++)
   {
   for (i = 1; i < numtextures; i++) // from 1 !!!
   {
   if (o[obj].texture == i) 
   {
   o[obj].m_dds = new char[strlen(tmp_m_dds[i])+1], o[obj].m_shd = new char[strlen(tmp_m_shd[i])+1],
   strcpy(o[obj].m_dds,tmp_m_dds[i]),strcpy(o[obj].m_shd,tmp_m_shd[i]);
   if (lmapFlag) if (tmp_m_lm_dds[i]) o[obj].m_lm_dds = new char[strlen(tmp_m_lm_dds[i])+1], strcpy(o[obj].m_lm_dds,tmp_m_lm_dds[i]);
   }
   }
	  if (o[obj].texture)
	  printf("o%05u - c,t,s 0x%02X, '%s', '%s', %u, %u\n",
  	obj,o[obj].code, o[obj].m_dds,o[obj].m_shd,o[obj].range[0].vCount,o[obj].range[0].iCount), numblocks++;
	  else
	  printf("o%05u - no texture\n",obj);
   }
   for (i = 0; i < numtextures; i++)
    delete tmp_m_dds[i], delete tmp_m_lm_dds[i], delete tmp_m_shd[i];

  printf("level parse complete\n");

   for (obj = 0; obj < ocount; obj++)
   {
	 printf("obj[%05u of %05u], making normales ... ",obj+1,ocount);
	 for (unsigned int s = 0; s < o[obj].range[0].iCount ; s+=3)
   {
   vector3f a,b,c,n;
	 a = o[obj].geom_vBlk[o[obj].geom_iBlk[s]].p;
	 b = o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].p;
	 c = o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].p;
   Make_Normal(a,b,c,&n);

#ifdef USE_NZYX
	if (o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x == 2)
	{
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n = 
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n = 
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n = n;
	}
#else
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n = 
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n = 
	 o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n = n;
#endif
/*
	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x - n.x) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		n.x, o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x = n.x;
   }
   else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.x);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y - n.y) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		n.y, o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y = n.y;
   }
   else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.y);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z - n.z) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		n.z, o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z = n.z;
   }
   else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s]].n.z);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x - n.x) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		n.x, o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x = n.x;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.x);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y - n.y) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		n.y, o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y = n.y;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.y);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z - n.z) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		n.z, o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z = n.z;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+1],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+1]].n.z);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x - n.x) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		n.x, o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x = n.x;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.X %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.x);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y - n.y) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		n.y, o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y = n.y;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Y %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.y);

	 if (fabs(o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z - n.z) > 0.003922)
	 {
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z calculated %f was %f\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		n.z, o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z);
			//o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z = n.z;
   }
	 else
	 printf("obj[%02u].type[0x%02X].v[%05u].normal.Z %f OK\n",obj,o[obj].code,o[obj].geom_iBlk[s+2],
		o[obj].geom_vBlk[o[obj].geom_iBlk[s+2]].n.z);
*/
   }
	 printf("OK\r");
   }
	 printf("\n");

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

	 hdr2.bb.min = hdr2.bb.max = o[0].bs.c;
   for (unsigned int ii = 0; ii < numblocks; ii++)
   {
		// find general bbox
   if (o[ii].bb.min.x < hdr2.bb.min.x) hdr2.bb.min.x = o[ii].bb.min.x;
   if (o[ii].bb.min.y < hdr2.bb.min.y) hdr2.bb.min.y = o[ii].bb.min.y;
   if (o[ii].bb.min.z < hdr2.bb.min.z) hdr2.bb.min.z = o[ii].bb.min.z;
   if (o[ii].bb.max.x > hdr2.bb.max.x) hdr2.bb.max.x = o[ii].bb.max.x;
   if (o[ii].bb.max.y > hdr2.bb.max.y) hdr2.bb.max.y = o[ii].bb.max.y;
   if (o[ii].bb.max.z > hdr2.bb.max.z) hdr2.bb.max.z = o[ii].bb.max.z;
   }

  unsigned int tot_i = 0, tot_v = 0;

  printf("creating '%s'\n",fileName);
  outputFile = fopen(fileName,"wb");

  ChunkIFF * ih = new ChunkIFF;
  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  OGFHeader_v4 * hdr4 = new OGFHeader_v4;
  hdr4->format_version = 4;
  hdr4->type = 1;
  hdr4->shader_id = 0;
  hdr4->bb = hdr2.bb;
  hdr4->bs.r = (Dist3D(hdr2.bb.min.x,hdr2.bb.min.y,hdr2.bb.min.z,hdr2.bb.max.x,hdr2.bb.max.y,hdr2.bb.max.z)/ 2.0f);
  hdr4->bs.c.x = ((hdr2.bb.min.x + hdr2.bb.max.x) / 2.0f);
  hdr4->bs.c.y = ((hdr2.bb.min.y + hdr2.bb.max.y) / 2.0f);
  hdr4->bs.c.z = ((hdr2.bb.min.z + hdr2.bb.max.z) / 2.0f);
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x12; // text info
  if (argc > 3) ih->size = 0x59 + strlen(intName); else ih->size = 0x6E; // guessed :)
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  i = 0; 
  if (argc > 3) 
  fprintf(outputFile,"%s.object",intName);
  else fputs("test_level\\test_level.object",outputFile);
  fwrite(&i,1,1,outputFile); 

  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time

  ih->type = 0x09; // childrens
  ih->size = 0;
	for (j = 0;j < numblocks; j++)
	{
	if (lodsFlag) if (strstr(o[j].m_dds,"prop_fake")) continue;
  if (!lmapFlag) {
	ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
#ifdef USE_LODS
	if (o[j].lodcount)
  ih->size += (sizeof(swidata)+(sizeof(slide_window)*o[j].lodcount))+8;
#endif
	} // !mapFlag
	if (lmapFlag) if (o[j].dds_type == 1) printf("************** lmap is '%s'\n",o[j].m_lm_dds),
  ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_lm_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
  }

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  printf("making %u blocks\n",numblocks);

  unsigned int k = 0;
	for (j = 0;j < numblocks; j++)
	{
	if (lodsFlag) if (strstr(o[j].m_dds,"prop_fake")) continue;

	if (!lmapFlag) {
	// child start

  ih->type = k; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
#ifdef USE_LODS
	if (o[j].lodcount)
  ih->size += (sizeof(swidata)+(sizeof(slide_window)*o[j].lodcount))+8;
#endif

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	// .... 1.2.3.4

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb = o[j].bb;
  hdr4->bs = o[j].bs;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x02; // texture
  ih->size = strlen(o[j].m_dds) + strlen(o[j].m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(o[j].m_dds,outputFile); fwrite(&i,1,1,outputFile); 
  fputs(o[j].m_shd,outputFile); fwrite(&i,1,1,outputFile); 

	tot_v += o[j].range[0].vCount;
  ih->type = 0x03; // verts
  ih->size = (o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = o[j].range[0].vCount; 
  fwrite(&i,4,1,outputFile);
  for (unsigned int s = 0; s < i ; s++)
	fwrite(&o[j].geom_vBlk[s],sizeof(OGFVertex_v0)-8,1,outputFile);
	
	tot_i += o[j].range[0].iCount;
  ih->type = 0x04; // idx
  ih->size = (o[j].range[0].iCount*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = o[j].range[0].iCount; 
  fwrite(&i,4,1,outputFile);
	fwrite(o[j].geom_iBlk,sizeof(unsigned short),i,outputFile);

#ifdef USE_LODS
	if (o[j].lodcount)
	{
	swidata s;
  ih->type = 0x06; // lod
  ih->size = sizeof(swidata)+(sizeof(slide_window)*o[j].lodcount);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  s.swicout = o[j].lodcount;
	fwrite(&s,sizeof(swidata),1,outputFile);
	fwrite(o[j].lod,sizeof(slide_window),o[j].lodcount,outputFile);
	}
#endif

	printf("."); if ((k % 50)==0) printf("\r%u",k);
	k++;
	// child end 
	} // !lmapFlag

	if (lmapFlag) if (o[j].dds_type == 1) {
	// child start

  ih->type = k; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(o[j].m_lm_dds) + strlen(o[j].m_shd) + 0x02)+8)+(8+((o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((o[j].range[0].iCount*2)+4));
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	// .... 1.2.3.4

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb = o[j].bb;
  hdr4->bs = o[j].bs;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x02; // texture
  ih->size = strlen(o[j].m_lm_dds) + strlen(o[j].m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(o[j].m_lm_dds,outputFile); fwrite(&i,1,1,outputFile);
  fputs(o[j].m_shd,outputFile); fwrite(&i,1,1,outputFile);
	tot_v += o[j].range[0].vCount;
  ih->type = 0x03; // verts
  ih->size = (o[j].range[0].vCount*(sizeof(OGFVertex_v0)-8))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = o[j].range[0].vCount;
  fwrite(&i,4,1,outputFile);
  for (unsigned int s = 0; s < i ; s++)
  o[j].geom_vBlk[s].u = o[j].geom_vBlk[s].lu, o[j].geom_vBlk[s].v = o[j].geom_vBlk[s].lv,
  //o[j].geom_vBlk[s].p.y+=0.01f, // lmap is upper
	fwrite(&o[j].geom_vBlk[s],sizeof(OGFVertex_v0)-8,1,outputFile);
	
	tot_i += o[j].range[0].iCount;
  ih->type = 0x04; // idx
  ih->size = (o[j].range[0].iCount*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = o[j].range[0].iCount;
  fwrite(&i,4,1,outputFile);
	fwrite(o[j].geom_iBlk,sizeof(unsigned short),i,outputFile);

	printf("*"); if ((k % 50)==0) printf("\r%u",k);
	k++;
	// child end (lmap)
	}
	}

  delete [] o;

  delete hdr4;
  delete ih;

  if (outputFile) fclose(outputFile);
  if (argc > 3) printf("\nwriting level '%s' to '%s' [v %u, i %u] OK\n",intName,fileName,tot_v,tot_i);
	else printf("\nwriting '%s' [v %u, i %u] OK\n",fileName,tot_v,tot_i);
#ifdef _WIN32
	QueryPerformanceCounter(&FPSCount1);
	printf("_MSC_VER=%u, %2.4f sec ", _MSC_VER, (float)(FPSCount1.QuadPart-FPSCount0.QuadPart)/CounterFrequency.QuadPart);
	printf("%6.4f ms\n", (float)(((FPSCount1.QuadPart-FPSCount0.QuadPart)*1000.0)/CounterFrequency.QuadPart));
#endif
#ifdef USE_OS2
	DosTmrQueryTime(&FPSCount1);
	printf("%2.4f sec ", (float)((*(unsigned long long*)&FPSCount1-*(unsigned long long*)&FPSCount0)/CounterFrequency));
	printf("%6.4f ms\n", (float)((*(unsigned long long*)&FPSCount1-*(unsigned long long*)&FPSCount0)*1000.0/CounterFrequency));
#endif
//    printf("before %u after %u diff %u, freq %u\n",
//		(unsigned int)FPSCount0.QuadPart, (unsigned int)FPSCount1.QuadPart, (unsigned int)(FPSCount1.QuadPart-FPSCount0.QuadPart), (unsigned int)CounterFrequency.QuadPart);
///////////////////////////////////////
} // parseFlag == 0
else if (parseFlag == 1) 

{

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

   for (unsigned int obj = 0; obj < ocount; obj++)
   {
   for (i = 1; i < numtextures; i++) // from 1 !!!
   {
   if (o[obj].texture == i) 
   {
   o[obj].m_dds = new char[strlen(tmp_m_dds[i])+1], o[obj].m_shd = new char[strlen(tmp_m_shd[i])+1],
   strcpy(o[obj].m_dds,tmp_m_dds[i]),strcpy(o[obj].m_shd,tmp_m_shd[i]);
   if (lmapFlag) if (tmp_m_lm_dds[i]) o[obj].m_lm_dds = new char[strlen(tmp_m_lm_dds[i])+1], strcpy(o[obj].m_lm_dds,tmp_m_lm_dds[i]);
   }
   }
   }

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
   
#define LINE_COMPACT
//////////////////////////////////////////
#ifdef LINE_COMPACT

   unsigned short mix_numt=0;
 
   printf(" compacting (full): first pass\n");
   for (unsigned short t = 1; t < numtextures; t++) // from 1 !!!
   {
   unsigned int max_v=0, max_i=0;
   for (unsigned int obj = 0; obj < ocount; obj++)
   if ((o[obj].texture == t) && (o[obj].range[0].vCount)) 
   {
   //printf(" -> obj = %u, v = %u, i = %u\n",obj,o[obj].range[0].vCount,o[obj].range[0].iCount);
   unsigned int vtmp = max_v + o[obj].range[0].vCount;
   if (vtmp <= 65535)
   max_v += o[obj].range[0].vCount, max_i += o[obj].range[0].iCount;
   //printf("obj %u chained\n",obj);
   else
   {
   //printf("obj %u eof\n",obj);
   printf("%05i: *texture='%s', max_v=%u, max_i=%u\n",t,tmp_m_dds[t],max_v,max_i);
   mix[mix_numt].texture = t;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[t])], mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[t])],
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[t]),strcpy(mix[mix_numt].m_shd,tmp_m_shd[t]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   //printf(" [%u]:create of vblk[%u],iblk[%u]\n",mix_numt,max_v,max_i);
   //printf(" pre-v\n");
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   //printf(" pre-i\n");
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   //printf(" done make\n");
   mix_numt++;
   max_v = o[obj].range[0].vCount, max_i = o[obj].range[0].iCount;
   }
   }
   if (max_v)
   {
   printf("%05i: +texture='%s', max_v=%u, max_i=%u\n",t,tmp_m_dds[t],max_v,max_i);
   mix[mix_numt].texture = t;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[t])], mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[t])],
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[t]),strcpy(mix[mix_numt].m_shd,tmp_m_shd[t]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   //printf(" [%u]:create of vblk[%u],iblk[%u]\n",mix_numt,max_v,max_i);
   //printf(" pre-v\n");
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   //printf(" pre-i\n");
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   //printf(" done make\n");
   mix_numt++;
   }
   }

   printf(" compacting (full): second pass\n");
   for (i = 0; i < mix_numt; i++)
   {

   unsigned int v_pos = 0, i_pos = 0;
   for (unsigned int obj = 0; obj < ocount; obj++)
   if (mix[i].texture == o[obj].texture)
   {
   unsigned int v_tmp = v_pos + o[obj].range[0].vCount;
   if (v_tmp <= mix[i].vCount)
   {
   memcpy(&mix[i].geom_vBlk[v_pos],o[obj].geom_vBlk,sizeof(OGFVertex_v0)*o[obj].range[0].vCount);
   memcpy(&mix[i].geom_iBlk[i_pos],o[obj].geom_iBlk,sizeof(unsigned short)*o[obj].range[0].iCount);
   if (i_pos) for (unsigned int ii = 0; ii < o[obj].range[0].iCount; ii++)
   mix[i].geom_iBlk[i_pos+ii] += (unsigned short)v_pos;
   v_pos += o[obj].range[0].vCount;
   i_pos += o[obj].range[0].iCount;
   }
   else
   {
   printf("*mix_num %u: max_v=%u, max_i=%u\n",i,v_pos,i_pos);
   i++;
   v_pos = 0; i_pos = 0;
   memcpy(&mix[i].geom_vBlk[v_pos],o[obj].geom_vBlk,sizeof(OGFVertex_v0)*o[obj].range[0].vCount);
   memcpy(&mix[i].geom_iBlk[i_pos],o[obj].geom_iBlk,sizeof(unsigned short)*o[obj].range[0].iCount);
   // if (i_pos) for (unsigned int ii = 0; ii < o[obj].range[0].iCount; ii++)
   // mix[i].geom_iBlk[i_pos+ii] += (unsigned short)v_pos;
   v_pos += o[obj].range[0].vCount;
   i_pos += o[obj].range[0].iCount;
   }
   }
   printf("+mix_num %u: max_v=%u, max_i=%u\n",i,v_pos,i_pos);

   }
   
/////////////////////////
#else // partial compact
/////////////////////////

   unsigned short mix_numt=0, m_first = 0, m_last = 0;
   unsigned int max_v = 0, max_i = 0;

   printf(" compacting (partial,line): first pass\n");

   for (obj = 0; obj < ocount; obj++) // from 1
   {
   printf("  blk [%u]: ",obj);

   unsigned int vtmp = max_v + o[obj].range[0].vCount;
   if (vtmp > 65535) printf("[v overflow '%s'] ",tmp_m_dds[o[obj].texture]);
   if ((o[obj].texture == o[m_first].texture) && (vtmp <= 65535))
   {
   printf("merge into [%u]\n",m_first);
   max_v += o[obj].range[0].vCount;
   max_i += o[obj].range[0].iCount;
   m_last = obj;
   }
   else
   {
   printf("delayed\n");
   printf(" *blk %u completed: ",mix_numt);
   mix[mix_numt].texture = o[m_first].texture;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[o[m_first].texture])];
   mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[o[m_first].texture])];
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[o[m_first].texture]);
   strcpy(mix[mix_numt].m_shd,tmp_m_shd[o[m_first].texture]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   int i_pos=0, v_pos=0;
   for (unsigned int m = m_first; m <= m_last; m++)
   {
   memcpy(&mix[mix_numt].geom_vBlk[v_pos],o[m].geom_vBlk,sizeof(OGFVertex_v0)*o[m].range[0].vCount);
   memcpy(&mix[mix_numt].geom_iBlk[i_pos],o[m].geom_iBlk,sizeof(unsigned short)*o[m].range[0].iCount);

   if (i_pos) for (unsigned int ii = 0; ii < o[m].range[0].iCount; ii++)
   mix[mix_numt].geom_iBlk[i_pos+ii] += v_pos;

   v_pos += o[m].range[0].vCount;
   i_pos += o[m].range[0].iCount;

   }
   printf("max_v=%u, max_i=%u, v_pos=%u, i_pos=%u\n",max_v,max_i,v_pos,i_pos);
   mix_numt++;
   max_v = max_i = v_pos = i_pos = 0;
   obj = m_last;
   m_first = m_last + 1; m_last = m_first;
   }
   }

/////////////////////////

   // finish
   printf(" +blk %u completed: ",mix_numt);
   mix[mix_numt].texture = o[m_first].texture;
   mix[mix_numt].m_dds = new char[strlen(tmp_m_dds[o[m_first].texture])];
   mix[mix_numt].m_shd = new char[strlen(tmp_m_shd[o[m_first].texture])];
   strcpy(mix[mix_numt].m_dds,tmp_m_dds[o[m_first].texture]);
   strcpy(mix[mix_numt].m_shd,tmp_m_shd[o[m_first].texture]);
   mix[mix_numt].vCount = max_v;
   mix[mix_numt].iCount = max_i;
   mix[mix_numt].geom_vBlk = new OGFVertex_v0[max_v];
   mix[mix_numt].geom_iBlk = new unsigned short[max_i];
   unsigned int i_pos=0, v_pos=0;
   for (unsigned int m = m_first; m <= m_last; m++)
   {
   memcpy(&mix[mix_numt].geom_vBlk[v_pos],o[m].geom_vBlk,sizeof(OGFVertex_v0)*o[m].range[0].vCount);
   memcpy(&mix[mix_numt].geom_iBlk[i_pos],o[m].geom_iBlk,sizeof(unsigned short)*o[m].range[0].iCount);

   if (i_pos) for (unsigned int ii = 0; ii < o[m].range[0].iCount; ii++)
   mix[mix_numt].geom_iBlk[i_pos+ii] += v_pos;
   }
   printf("max_v=%u, max_i=%u\n",mix_numt,v_pos,i_pos);
   mix_numt++;
#endif
//////////////////////////////////////////////////////////////////

  printf("parse complete\n");

  unsigned int tot_i = 0, tot_v = 0;

   for (i = 1; i < numtextures; i++)
    delete tmp_m_dds[i], delete tmp_m_lm_dds[i], delete tmp_m_shd[i];
   delete [] o;

///////////////////////////////////////
  printf("creating '%s'\n",fileName);
  outputFile = fopen(fileName,"wb");

  ChunkIFF * ih = new ChunkIFF;
  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  OGFHeader_v4 * hdr4 = new OGFHeader_v4;
  hdr4->format_version = 4;
  hdr4->type = 1;
  hdr4->shader_id = 0;
  // zero fill all :)
  hdr4->bs.r =
  hdr4->bs.c.x = 
  hdr4->bs.c.y = 
  hdr4->bs.c.z = 0.0f;
	hdr4->bb.min = hdr4->bb.max = hdr4->bs.c;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x12; // text info
  if (argc > 3) ih->size = 0x59 + strlen(intName); else ih->size = 0x6E; // guessed :)
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  i = 0; 
  if (argc > 3) 
  fprintf(outputFile,"%s.object",intName);
  else fputs("test_level\\test_level.object",outputFile);
  fwrite(&i,1,1,outputFile); 

  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time

  ih->type = 0x09; // childrens
  ih->size = 0;
	for (j = 0;j < mix_numt; j++)
	{
	if (lodsFlag) if (strstr(mix[j].m_dds,"prop_fake")) continue;
  ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(mix[j].m_dds) + strlen(mix[j].m_shd) + 0x02)+8)+(8+((mix[j].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((mix[j].iCount*2)+4));
  }

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  printf("making %u blocks\n",mix_numt);

	for (j = 0;j < mix_numt; j++)
	{
	if (lodsFlag) if (strstr(mix[j].m_dds,"prop_fake")) continue;

	// child start

  if (!mix[j].vCount) { printf(" blk: vCount is zero sized!!!\n"); continue; }
  if (!mix[j].iCount) { printf(" blk: iCount is zero sized!!!\n"); continue; }

  ih->type = j; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(mix[j].m_dds) + strlen(mix[j].m_shd) + 0x02)+8)+(8+((mix[j].vCount*(sizeof(OGFVertex_v0)-8))+8))+(8+((mix[j].iCount*2)+4));

	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	// .... 1.2.3.4

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb.min = hdr2.bb.min;
  hdr4->bb.max = hdr2.bb.max;
  // hdr4.bs ???
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x02; // texture
  ih->size = strlen(mix[j].m_dds) + strlen(mix[j].m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(mix[j].m_dds,outputFile); fwrite(&i,1,1,outputFile); 
  fputs(mix[j].m_shd,outputFile); fwrite(&i,1,1,outputFile); 

	tot_v+= mix[j].vCount;
  ih->type = 0x03; // verts
  ih->size = (mix[j].vCount*(sizeof(OGFVertex_v0)-8))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = mix[j].vCount;
  fwrite(&i,4,1,outputFile);
  for (unsigned int s = 0; s < i ; s++)
	fwrite(&mix[j].geom_vBlk[s],sizeof(OGFVertex_v0)-8,1,outputFile);
	
	tot_i+= mix[j].iCount;
  ih->type = 0x04; // idx
  ih->size = (mix[j].iCount*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = mix[j].iCount; 
  fwrite(&i,4,1,outputFile);
	fwrite(mix[j].geom_iBlk,sizeof(unsigned short),i,outputFile);

	printf("."); if ((j % 50)==0) printf("\r%u",j);
	// child end 
	}

  delete hdr4;
  delete ih;

  if (outputFile) fclose(outputFile);
  if (argc > 3) printf("\nwriting level '%s' to '%s' [v %u, i %u] OK\n",intName,fileName,tot_v,tot_i);
	else printf("\nwriting '%s' [v %u, i %u] OK\n",fileName,tot_v,tot_i);
///////////////////////////////////////

} // parseFlag == 2

	return 0;
	}
