#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <stdlib.h>

unsigned int numblocks, tot_v = 0, tot_i = 0;
char defuser[] = "\\\\MSHOME\\Administrator";

struct ChunkIFF
{
	unsigned int type, size;
};

struct vector3f
{
	float x,y,z; 
};

struct vector2f
{
	float tx,ty; 
};

struct face
{
	unsigned short f0,f1,f2; 
};

struct ogf_bbox {
	struct vector3f		min;
	struct vector3f		max;
};

struct ogf_bsphere {
	struct vector3f		c;
	float			r;
};

struct OGFVertex_v0a // 36 (0x24), OGF_VERTEXFORMAT_FVF
{
	struct vector3f p; // point
	struct vector3f n; // normal
	float u,v; // texture coordinates
	unsigned long bone;
};

struct OGFVertex_v0 // 32 (0x20), OGF_VERTEXFORMAT_FVF (x-ray actor_editor export)
{
	struct vector3f p; // point
	struct vector3f n; // normal
	float u,v;
};

struct OGFVertex_v1 // 60 (0x3C), OGF4_VERTEXFORMAT_FVF_1L, OGF4_VERTEXFORMAT_FVF_1L_CS
{
	struct vector3f p; // point
	struct vector3f n; // normal
	struct vector3f t; // tangent (for bump mapping)
	struct vector3f b; // binoral (for bump mapping)
	float u,v; // texture coordinates
	unsigned int bone;
};

struct OGFVertex_v2 // 64 (0x40), OGF4_VERTEXFORMAT_FVF_2L, OGF4_VERTEXFORMAT_FVF_2L_CS
{
	unsigned short bone[2];
	struct vector3f p; // point
	struct vector3f n; // normal
	struct vector3f t; // tangent (for bump mapping)
	struct vector3f b; // binoral (for bump mapping)
	float w; // weight
	float u,v; // texture coordinates
};

struct OGFVertex_v3 // 70 (0x46), OGF4_VERTEXFORMAT_FVF_3L, OGF4_VERTEXFORMAT_FVF_3L_CS
{
  unsigned short bone[3]; 
	struct vector3f p; // point
	struct vector3f n; // normal
	struct vector3f t; // tangent (for bump mapping)
	struct vector3f b; // binoral (for bump mapping)
	float w[2];
	float u,v; // texture coordinates
};

struct OGFVertex_v4 // 76 (0x4C), 	OGF4_VERTEXFORMAT_FVF_4L_CS
{
  unsigned short matrix[4]; 
	struct vector3f p; // point
	struct vector3f n; // normal
	struct vector3f t; // tangent (for bump mapping)
	struct vector3f b; // binoral (for bump mapping)
	float w[3];
	float u,v; // texture coordinates
};

struct swidata {
  unsigned int m_reserved[4];
  unsigned int swicout;
};

struct slide_window {
	unsigned int		offset;
	unsigned short		num_tris;
	unsigned short		num_verts;
};

struct OGFHeader_v3 // old
{
	unsigned char format_version;
	unsigned char type;
	unsigned short unknown;
};

struct OGFHeader_v4 // 0x2C (44)
{
 unsigned char format_version;
 unsigned char type;
 unsigned short shader_id;
 struct ogf_bbox		bb;
 struct ogf_bsphere	bs;
};

char mbuf[_MAX_PATH];

struct Vertices // 0x03
{
	unsigned long	ident;
	unsigned long	count;
	unsigned short	*vtx;
};

vector3f pos3, rot3;
unsigned int k=0;
ChunkIFF ki;

int DecodeChunk_v4(ChunkIFF chunk,FILE *inputFile,FILE *outputFile)
{
	Vertices v;
	unsigned int cnt;

	switch (chunk.type)
	{
	case 0x01:
	case 0x04:
		{
			fwrite(&ki,8,1,outputFile);
			char *tmpdata = new char[chunk.size];
		  fread(tmpdata,chunk.size,1,inputFile);
			fwrite(&chunk,8,1,outputFile);
		  fwrite(tmpdata,chunk.size,1,outputFile);
		  delete [] tmpdata;
			return 1;
		}
	case 0x02:
		{
		  ki.type = k; k++; // subid
		  ki.size = 0; // ???
			fwrite(&ki,8,1,outputFile);
			char *tmpdata = new char[chunk.size];
		  fread(tmpdata,chunk.size,1,inputFile);
			fwrite(&chunk,8,1,outputFile);
		  fwrite(tmpdata,chunk.size,1,outputFile);
		  delete [] tmpdata;
			return 1;
		}
	case 0x03: // sub: 0x03 OGF_VERTICES
		{
			fwrite(&chunk,8,1,outputFile);
			fread(&v,8,1,inputFile);
			fwrite(&v,8,1,outputFile);
			if ((v.ident == 0x1) || (v.ident == 0x12071980))
			{
				OGFVertex_v1 *vtx = new OGFVertex_v1[v.count];
				fread(vtx,sizeof(OGFVertex_v1),v.count,inputFile);
				for (cnt = 0; cnt < v.count; cnt++) 
				{
				vtx[cnt].p.x += pos3.x;	vtx[cnt].p.y += pos3.y; vtx[cnt].p.z += pos3.z;
				} 
				fwrite(vtx,sizeof(OGFVertex_v1),v.count,outputFile);
				delete [] vtx;
			} else if ((v.ident == 0x2) || (v.ident == 0x240e3300))
			{
				OGFVertex_v2 *vtx = new OGFVertex_v2[v.count];
				fread(vtx,sizeof(OGFVertex_v2),v.count,inputFile);
				for (cnt = 0; cnt < v.count; cnt++) 
				{
				vtx[cnt].p.x += pos3.x;	vtx[cnt].p.y += pos3.y; vtx[cnt].p.z += pos3.z;
				} 
				fwrite(vtx,sizeof(OGFVertex_v2),v.count,outputFile);
				delete [] vtx;
			} else if (v.ident == 0x3)
			{
				OGFVertex_v3 *vtx = new OGFVertex_v3[v.count];
				fread(vtx,sizeof(OGFVertex_v3),v.count,inputFile);
				for (cnt = 0; cnt < v.count; cnt++) 
				{
				vtx[cnt].p.x += pos3.x;	vtx[cnt].p.y += pos3.y; vtx[cnt].p.z += pos3.z;
				} 
				fwrite(vtx,sizeof(OGFVertex_v3),v.count,outputFile);
				delete [] vtx;
			} else if (v.ident == 0x4)
			{
				OGFVertex_v4 *vtx = new OGFVertex_v4[v.count];
				fread(vtx,sizeof(OGFVertex_v4),v.count,inputFile);
				for (cnt = 0; cnt < v.count; cnt++) 
				{
				vtx[cnt].p.x += pos3.x;	vtx[cnt].p.y += pos3.y; vtx[cnt].p.z += pos3.z;
				} 
				fwrite(vtx,sizeof(OGFVertex_v4),v.count,outputFile);
				delete [] vtx;
			} else if (v.ident == 0x00000112)
			{
				OGFVertex_v0 *vtx = new OGFVertex_v0[v.count];
				fread(vtx,sizeof(OGFVertex_v0),v.count,inputFile);
				for (cnt = 0; cnt < v.count; cnt++) 
				{
				vtx[cnt].p.x += pos3.x;	vtx[cnt].p.y += pos3.y; vtx[cnt].p.z += pos3.z;
				} 
				fwrite(vtx,sizeof(OGFVertex_v0),v.count,outputFile);
				delete [] vtx;
			}
			return 1;
		}
	case 0x05:
	case 0x06:
	case 0x07:  
	case 0x08: 
	case 0x0D:
	case 0x0E:
	case 0x10:
	case 0x11:
	case 0x12:
	default:{
		return 0;}
}
}

/////////////////////////////////////////////////////////

void parse_ogf(FILE * in_ogf, FILE * out_ogf)
{
	ChunkIFF ih;
  unsigned long pos, i, initsize=0, fullsize=0, subfullsize = 0, subsubfullsize = 0;
	unsigned short subid=0;

	for (;;)
	{
		if (fread( &ih.type, 4, 1, in_ogf ) == 0) break;
		if ((ih.type !=9)) { //  || (modeltype == 1)
			fread( &ih.size, 4, 1, in_ogf );
			printf("\t\tChunk #:0x%04lX, size is 0x%08lX (%u)\n",ih.type,ih.size,ih.size);
			if (DecodeChunk_v4(ih,in_ogf,out_ogf) == 0)
				pos = ftell(in_ogf) + ih.size, fseek(in_ogf, pos, SEEK_SET); // jump over
				fullsize+= 8;fullsize+= ih.size;
		}
		else {
			fread( &ih.size, 4, 1, in_ogf );
			printf("\t\tChunk #:0x%04lX, size is 0x%08lX (%u)\n",ih.type,ih.size,ih.size);
			fullsize+= 8;fullsize+= ih.size;
			// sub#1
			subfullsize = ih.size;
			for (;;)
			{
				fread( &ih, 8, 1, in_ogf );
				//fwrite(&ih, 8, 1, out_ogf );
				printf("\t\t--> SubChunk #:0x%04lX, size is 0x%08lX (%u)\n",ih.type,ih.size,ih.size);
				subfullsize-= 8;subfullsize-= ih.size;
				if (ih.type == subid) {
					// sub#2
					subsubfullsize = ih.size; printf("\n");
					for (;;)
					{
						fread( &ih, 8, 1, in_ogf );
						printf("\t\t----> Chunk #:0x%04lX, size is 0x%08lX (%u)\n",ih.type,ih.size,ih.size);
						if (DecodeChunk_v4(ih,in_ogf,out_ogf) == 0)
							pos = ftell(in_ogf) + ih.size, fseek(in_ogf, pos, SEEK_SET); // jump over
							subsubfullsize-= 8;subsubfullsize-= ih.size;
							if (!subsubfullsize) { subid++; break; }
					}
				} else {
					if (DecodeChunk_v4(ih,in_ogf,out_ogf) == 0)
						pos = ftell(in_ogf) + ih.size, fseek(in_ogf, pos, SEEK_SET); // jump over
				}
				// sub#2
				if (!subfullsize) break;
			}
			// sub#1
		}
  }

	printf("\t\tFull size is 0x%08X (%u)\n",fullsize,fullsize);
}

int main(int argc, char* argv[])
{
	ChunkIFF ih;
  unsigned long i, fullsize=0, initsize=0, p;
	char fileName[256], *m_PathToStalker;
	char szBuffer[_MAX_PATH];
	extern char mbuf[_MAX_PATH]; // printf messages
  FILE *inputFile, *outputFile;
	vector3f v3;

 	printf("X-Ray spawn (2xxx+) parser-converter [201308xx]\n");
	if (argc < 3) 
  {
		printf("usage: parse_spw < game.spawn > < output.ogf >\n");
		return 1;
	}

//////////////////////////////////////////////
	FILE * f;
	
#ifdef WIN32
	strcpy(mbuf, GetCommandLine()+1);
	char *ch = mbuf + strlen(mbuf);
	while(*ch!='\\')ch--;
	strcpy(ch, "\\OGFViewer.cfg");
	
	if ((f = fopen(mbuf,"rb")) || (f = fopen("OGFViewer.cfg","rb")))
#else
		if (f = fopen("OGFViewer.cfg","rb"))
#endif
		{
			fread( szBuffer, 1, sizeof( szBuffer ), f );
			fclose(f);
		} else {
			printf("Can't open file: OGFViewer.cfg\n");
			sprintf(szBuffer,"gamedata\\textures\\");
		}
		m_PathToStalker = (char*)&szBuffer;
//////////////////////////////////////////////

	strcpy((char*)fileName,argv[1]);
  inputFile = fopen(fileName,"rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open for read.\n");
  return 1;
  }

	strcpy((char*)fileName,argv[2]);
  outputFile = fopen(fileName,"wb");
	if(!outputFile)
  {
 	printf("ERR: cannot open for write.\n");
  return 1;
  }

  OGFHeader_v4 * hdr4 = new OGFHeader_v4;
  ih.type = 0x01; // header
  ih.size = sizeof(OGFHeader_v4);
	fwrite(&ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 
  hdr4->shader_id = 
  hdr4->bb.min.x = 
  hdr4->bb.min.y = 
  hdr4->bb.min.z = 
  hdr4->bb.max.x = 
  hdr4->bb.max.y = 
  hdr4->bb.max.z = 
  hdr4->bs.c.x =
  hdr4->bs.c.y =
  hdr4->bs.c.z = 
  hdr4->bs.r = 0;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih.type = 9;
  ih.size = 0; // ???
	fwrite(&ih,sizeof(ChunkIFF),1,outputFile);


	fseek(inputFile,0,SEEK_END);
  fullsize = ftell(inputFile);
	fseek(inputFile,0,SEEK_SET);
	while(initsize < fullsize)
	{
  fread( &ih, sizeof(ChunkIFF), 1, inputFile );
  printf("\nId 0x%04X, size 0x%04X -\n",ih.type,ih.size);
  initsize+=8;

	char *tmpdata = new char[ih.size];
	fread(tmpdata,ih.size,1,inputFile);
	p = 2; // skip word 
	if ((strstr(&tmpdata[p],"m_tra")) ||
	(strstr(&tmpdata[p],"level_ch")) ||
	(strstr(&tmpdata[p],"_e")) ||
	(strstr(&tmpdata[p],"bloodsucker")) ||
	(strstr(&tmpdata[p],"zombie")) ||
	(strstr(&tmpdata[p],"snork")) ||
	(strstr(&tmpdata[p],"m_crow")) ||
	(strstr(&tmpdata[p],"stalker")) ||
	(strstr(&tmpdata[p],"normal")) ||
	(strstr(&tmpdata[p],"strong")) ||
	(strstr(&tmpdata[p],"weak")) ||
	(strstr(&tmpdata[p],"dog")) ||
	(strstr(&tmpdata[p],"boar")) ||
	(strstr(&tmpdata[p],"flesh")) ||
	(strstr(&tmpdata[p],"quest_")) ||
	(strstr(&tmpdata[p],"helic")) ||
	(strstr(&tmpdata[p],"respawn")) ||
	(strstr(&tmpdata[p],"zone_")) ||
	(strstr(&tmpdata[p],"space_")) ||
	(strstr(&tmpdata[p],"smart_")) ||
	(strstr(&tmpdata[p],"graph_")) ||
	(strstr(&tmpdata[p],"climable_object")) ||
	(strstr(&tmpdata[p],"actor"))) { printf("\tskipped: '%s'\n",&tmpdata[p]); goto next; }
	printf("\tsection [%s]",&tmpdata[p]);
	i = strlen(&tmpdata[p]); p += i; p++;
	printf(", name [%s]\n",&tmpdata[p]);
	i = strlen(&tmpdata[p]); p += i; p+= 3;
	v3 = *(vector3f*)&tmpdata[p]; p+= 12; pos3 = v3;
	printf("\tpos %.2f,%.2f,%.2f ", v3.x, v3.y, v3.z);
	v3 = *(vector3f*)&tmpdata[p]; p+= 12; rot3 = v3;
	printf("rot %.2f,%.2f,%.2f ", v3.x, v3.y, v3.z);
	p += 10; // skip 10 bytes
	printf("; ver %u, script_version %u\n", *(unsigned short*)&tmpdata[p], *(unsigned short*)&tmpdata[p+2]); p += 4;
	p += 0x19;
	while (p < (ih.size-8)) // search for double 0xFFFFFFFF
  {
	i = *(unsigned int*)&tmpdata[p];
	if ((i == 0xFFFFFFFF) && ((*(unsigned int*)&tmpdata[p+4]) == i)) goto proc_ok;
	p++;
  }
	printf("\tvisual BAD!!!\n");
	goto next;
proc_ok:
	p += 8;
	if (*(unsigned char*)&tmpdata[p] == 0) goto next;
	printf("\tvisual [%s]\n",&tmpdata[p]);

	sprintf(mbuf,"%s..\\meshes\\%s.ogf",m_PathToStalker, &tmpdata[p]);
	if (f = fopen(mbuf,"rb")) ;
	else
	{
	sprintf(mbuf,"%s.ogf",&tmpdata[p]); f = fopen(mbuf,"rb");
	}
	if (f) {
	printf("\t\tparsing '%s' ...\n", mbuf);
	parse_ogf(f, outputFile);
	}
	else
	printf("\t\t'%s.ogf' NOT found\n", &tmpdata[p]);
next:
	delete [] tmpdata;
  initsize+=ih.size;
  }
	printf("Full size is 0x%08X (%u)\n",fullsize,fullsize);

  fclose(inputFile);
  fclose(outputFile);
	return 0;
	}